import com.objsys.asn1j.runtime.*;
import java.io.*;

import com.objsys.nas.TS24301Msgs.*;
import com.objsys.nas.TS24301IES.*;
import com.objsys.nas.TS24008IES.*;
import com.objsys.nas.TS24007L3.*;

public class Writer {


   public static void main (String args[]) {
       String filename = new String ("message.dat");
       boolean trace = true;

      // Process command line arguments

      if (args.length > 0) {
         for (int i = 0; i < args.length; i++) {
            if (args[i].equals ("-v")) 
                Diag.instance().setEnabled (true);
            else if (args[i].equals ("-o")) 
                filename = new String (args[++i]);
            else if (args[i].equals ("-notrace")) trace = false;
            else {
                System.out.println ("usage: Writer [ -v ] [ -o <filename>");
                System.out.println ("   -v  verbose mode: print trace info");
                System.out.println ("   -o <filename>  " +
                                    "write encoded msg to <filename>");
                System.out.println ("   -notrace  do not display trace info");
                return;
            }
         }
      }

      // Create a data object and populate it with the data to be encoded
      com.objsys.nas.TS24301Msgs.PDU pdu = new PDU();
      com.objsys.nas.TS24301Msgs.TrkAreaUpdAccept data = new TrkAreaUpdAccept();
      com.objsys.nas.TS24301Msgs.TrkAreaUpdAccept pvalue = data;

      /* Populate data structure */
      pdu.protoDiscr = ProtoDiscr.epsMobMgmt();
      pdu.pti = new PDU_pti(PDU_pti._NOVALUE, null);
      pdu.l3HdrOpts = new L3HdrOptions();
      Asn1Integer tempVar1 = new Asn1Integer(0);
      pdu.l3HdrOpts.set_secHdr(tempVar1);
      pdu.msgType = new _NAS_PROTOCOL_CLASS_msgType(_TS24301MsgsValues.mt_TrkAreaUpdAccept);
      pdu.data = pvalue;
      pvalue.spare = new Asn1Integer(0);
      pvalue.epsUpdateResult = new EPSUpdateResult();
      pvalue.epsUpdateResult.spare = new Asn1Boolean(false);
      pvalue.epsUpdateResult.result = EPSUpdateResultValues.valueOf(1);
      pvalue.t3412Value = new GPRSTimer();
      pvalue.t3412Value.unit = new Asn1Integer(5);
      pvalue.t3412Value.timerValue = new Asn1Integer(30);
      pvalue.guti = new EPSMobileIdentity();
      pvalue.guti.length = new Asn1Integer(0); /* will be calculated */
      pvalue.guti.typeOfIdent = EPSMobileIdentity_typeOfIdent.imsi();
      pvalue.guti.content = new EPSMobileIdentity_content();
      pvalue.guti.content.set_imsi( new IMSI("40407123456789"));

      pvalue.taiList = new TrackingAreaIdentList();
      pvalue.taiList.length = new Asn1Integer(0); /* will be calculated */
      pvalue.taiList.idents = new TrackingAreaIdentList_idents();
      pvalue.taiList.idents.elements = new TrackingAreaIdentListItem[1];
      pvalue.taiList.idents.elements[0] = new TrackingAreaIdentListItem();
      pvalue.taiList.idents.elements[0].spare = new Asn1Boolean(false);
      pvalue.taiList.idents.elements[0].typeOfList = new Asn1Integer(0);
      pvalue.taiList.idents.elements[0].numElements = new Asn1Integer(0); /* +1 */
      pvalue.taiList.idents.elements[0].elements = new TrackingAreaIdentListItem_elements();
      PartialTrkAreaIdent0 tempVar3 = new PartialTrkAreaIdent0();
      pvalue.taiList.idents.elements[0].elements.set_partTrkIdentList0(tempVar3);
      tempVar3.mcc_mnc = new MCCMNCPair();
      tempVar3.mcc_mnc.mcc = new TBCDString3("260");
      tempVar3.mcc_mnc.mnc = new TBCDString3("03");
      tempVar3.tacs = new TrackingAreaCode[1];
      {
          byte testdata[] = {
         (byte)0xd5, (byte)0xb0 };
         tempVar3.tacs[0] = new TrackingAreaCode();
         tempVar3.tacs[0].value = testdata;
      }

      pvalue.epsBearerContextStatus = new EPSBearerContextStatus();
      pvalue.epsBearerContextStatus.ebi7 = new Asn1Boolean(false);
      pvalue.epsBearerContextStatus.ebi6 = new Asn1Boolean(false);
      pvalue.epsBearerContextStatus.ebi5 = new Asn1Boolean(false);
      pvalue.epsBearerContextStatus.ebi4 = new Asn1Boolean(false);
      pvalue.epsBearerContextStatus.ebi3 = new Asn1Boolean(false);
      pvalue.epsBearerContextStatus.ebi2 = new Asn1Boolean(false);
      pvalue.epsBearerContextStatus.ebi1 = new Asn1Boolean(false);
      pvalue.epsBearerContextStatus.ebi0 = new Asn1Boolean(true);
      pvalue.epsBearerContextStatus.ebi15 = new Asn1Boolean(false);
      pvalue.epsBearerContextStatus.ebi14 = new Asn1Boolean(false);
      pvalue.epsBearerContextStatus.ebi13 = new Asn1Boolean(true);
      pvalue.epsBearerContextStatus.ebi12 = new Asn1Boolean(false);
      pvalue.epsBearerContextStatus.ebi11 = new Asn1Boolean(true);
      pvalue.epsBearerContextStatus.ebi10 = new Asn1Boolean(true);
      pvalue.epsBearerContextStatus.ebi9 = new Asn1Boolean(false);
      pvalue.epsBearerContextStatus.ebi8 = new Asn1Boolean(true);
      pvalue.locAreaIdent = new LocAreaIdent();
      pvalue.locAreaIdent.mcc_mnc = new MCCMNCPair();
      pvalue.locAreaIdent.mcc_mnc.mcc = new TBCDString3("250");
      pvalue.locAreaIdent.mcc_mnc.mnc = new TBCDString3("05");
      pvalue.locAreaIdent.lac = new Asn1Integer(16694);
      pvalue.msIdentity = new MobileIdentity();
      MobileIdentity_TMGI tempVar6 = new MobileIdentity_TMGI();
      pvalue.msIdentity.set_tmgi(tempVar6);

      tempVar6.mbmsSessIdInd = new Asn1Boolean(true);
      tempVar6.mccMncInd = new Asn1Boolean(true);
      {
          byte testdata[] = {
         (byte)0x0e, (byte)0x3b, (byte)0x14 };
         tempVar6.mbmsServiceID = new Asn1OctetString(testdata);
      }
      tempVar6.mcc_mnc = new MCCMNCPair();
      tempVar6.mcc_mnc.mcc = new TBCDString3("525");
      tempVar6.mcc_mnc.mnc = new TBCDString3("01");
      tempVar6.mbmsSessionID = new Asn1Integer(174);

      pvalue.emmCause = EMMCause.imsiUnkInHSS();
      pvalue.t3402Value = new GPRSTimer();
      pvalue.t3402Value.unit = new Asn1Integer(0);
      pvalue.t3402Value.timerValue = new Asn1Integer(7);
      pvalue.t3423Value = new GPRSTimer();
      pvalue.t3423Value.unit = new Asn1Integer(5);
      pvalue.t3423Value.timerValue = new Asn1Integer(27);
      pvalue.equivalentPLMNs = new PLMNList();
      pvalue.equivalentPLMNs.elements = new MCCMNCPair[1];
      pvalue.equivalentPLMNs.elements[0] = new MCCMNCPair();
      pvalue.equivalentPLMNs.elements[0].mcc = new TBCDString3("456");
      pvalue.equivalentPLMNs.elements[0].mnc = new TBCDString3("02");
      pvalue.emergencyNumberList = new EmergencyNumberList();
      pvalue.emergencyNumberList.length = new Asn1Integer(0); /* will be calculated */
      pvalue.emergencyNumberList.numbers = new EmergencyNumberList_numbers();
      pvalue.emergencyNumberList.numbers.elements = new EmergencyNumber[1];
      pvalue.emergencyNumberList.numbers.elements[0] = new EmergencyNumber();
      pvalue.emergencyNumberList.numbers.elements[0].length = new Asn1Integer(0);
      pvalue.emergencyNumberList.numbers.elements[0].spare = new Asn1Integer(0);
      pvalue.emergencyNumberList.numbers.elements[0].catValue = new Asn1Integer(18);
      pvalue.emergencyNumberList.numbers.elements[0].digits = new TBCDString("37b##1");
      pvalue.epsNetworkFeatureSupport = new EPSNetworkFeatureSupport();
      pvalue.epsNetworkFeatureSupport.length = new Asn1Integer(1);
      pvalue.epsNetworkFeatureSupport.cpCIoT = new Asn1Boolean(false);
      pvalue.epsNetworkFeatureSupport.erNoPDN = new Asn1Boolean(true);
      pvalue.epsNetworkFeatureSupport.esr = new Asn1Boolean(true);
      pvalue.epsNetworkFeatureSupport.csLCS = new Asn1Integer(2);
      pvalue.epsNetworkFeatureSupport.epcLCS = new Asn1Boolean(false);
      pvalue.epsNetworkFeatureSupport.emcBS = new Asn1Boolean(true);
      pvalue.epsNetworkFeatureSupport.imsVoPS = new Asn1Boolean(true);
      pvalue.addnUpdateResult = new AddnUpdateResult();
      pvalue.addnUpdateResult.spare = new Asn1Integer(2);
      pvalue.addnUpdateResult.value = AddnUpdateResult_value.noInfo();

      // Create a message buffer object and encode the record

      Asn1NasEncodeBuffer encodeBuffer = new Asn1NasEncodeBuffer();

      // Enable bit field tracing

      if (trace) {
         encodeBuffer.getTraceHandler().enable();
      }  

      try {

          pdu.encode (encodeBuffer);

          if (trace) {
              System.out.println ("Encoding was successful");
              System.out.println ("Hex dump of encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump:");
              encodeBuffer.binDump ("message");
          }

          // Write the encoded record to a file

          encodeBuffer.write (new FileOutputStream (filename));

          // Generate a dump file for comparisons

          encodeBuffer.hexDump 
              (new PrintStream (new FileOutputStream ("message.dmp")));
      }
      catch (Exception e) {
          if (trace) {
              System.out.println ("Hex dump of partially encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump of partially encoded record:");
              encodeBuffer.binDump ("message");
          }

          System.out.println (e.getMessage());
          e.printStackTrace();           
          System.exit(-1);
      }
   }
}
