import com.objsys.asn1j.runtime.*;
import java.io.*;

import com.objsys.nas.TS24501Msgs.*;
import com.objsys.nas.TS24501IES.*;
import com.objsys.nas.TS24301IES.*;
import com.objsys.nas.TS24008IES.*;

public class Writer {


   public static void main (String args[]) {
       String filename = new String ("message.dat");
       boolean trace = true;

      // Process command line arguments

      if (args.length > 0) {
         for (int i = 0; i < args.length; i++) {
            if (args[i].equals ("-v")) 
                Diag.instance().setEnabled (true);
            else if (args[i].equals ("-o")) 
                filename = new String (args[++i]);
            else if (args[i].equals ("-notrace")) trace = false;
            else {
                System.out.println ("usage: Writer [ -v ] [ -o <filename>");
                System.out.println ("   -v  verbose mode: print trace info");
                System.out.println ("   -o <filename>  " +
                                    "write encoded msg to <filename>");
                System.out.println ("   -notrace  do not display trace info");
                return;
            }
         }
      }

      // Create a data object and populate it with the data to be encoded
      com.objsys.nas.TS24501Msgs.PDU pdu = new PDU();
      com.objsys.nas.TS24501Msgs.CfgUpdateCmd data = new CfgUpdateCmd();
      com.objsys.nas.TS24501Msgs.CfgUpdateCmd pvalue = data;

      /* Populate data structure */
      pdu.protoDiscr = NAS5GProtoDiscr.mobMgmt5G();
      pdu.hdrData = new PDU_hdrData();
      PDU_hdrData_mm tempVar1 = new PDU_hdrData_mm();
      pdu.hdrData.set_mm(tempVar1);

      tempVar1.secHdrType = NAS5GSecHdrType.noSec();
      pdu.msgType = new _NAS5G_PROTOCOL_CLASS_msgType(_TS24501MsgsValues.mt_CfgUpdateCmd5G);
      pdu.data = pvalue;
      pvalue.cfgUpdIndication = new ConfigUpdateIndication();
      pvalue.cfgUpdIndication.regRequested = new Asn1Boolean(true);
      pvalue.cfgUpdIndication.ack = new Asn1Boolean(false);
      pvalue.guti = new com.objsys.nas.TS24501IES.MobileIdentity();
      MobileIdentity_GUTI tempVar2 = new MobileIdentity_GUTI();
      pvalue.guti.set_guti(tempVar2);

      tempVar2.mcc_mnc = new MCCMNCPair();
      tempVar2.mcc_mnc.mcc = new TBCDString3("404");
      tempVar2.mcc_mnc.mnc = new TBCDString3("585");
      tempVar2.amfRegionID = new Asn1Integer(0xda);
      tempVar2.amfSetID = new Asn1Integer(8);
      tempVar2.amfPointer = new Asn1Integer(2);
      {
          byte testdata[] = { 
         (byte)0x9f, (byte)0x14, (byte)0x6b, (byte)0x69 };
         tempVar2.tmsi = new Asn1OctetString(testdata);
      }
      pvalue.taiList = new com.objsys.nas.TS24501IES.TrackingAreaIdentList();
      pvalue.taiList.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.taiList.idents = new com.objsys.nas.TS24501IES.TrackingAreaIdentListItem[1];
      pvalue.taiList.idents[0] = new com.objsys.nas.TS24501IES.TrackingAreaIdentListItem();
      pvalue.taiList.idents[0].allowedType = new Asn1Boolean(false);
      pvalue.taiList.idents[0].typeOfList = new Asn1Integer(0);
      pvalue.taiList.idents[0].numElements = new Asn1Integer(8);
      pvalue.taiList.idents[0].elements = new com.objsys.nas.TS24501IES.TrackingAreaIdentListItem_elements();
      com.objsys.nas.TS24501IES.PartialTrkAreaIdent0 tempVar3 = new com.objsys.nas.TS24501IES.PartialTrkAreaIdent0();
      pvalue.taiList.idents[0].elements.set_partTrkIdentList0(tempVar3);

      tempVar3.mcc_mnc = new MCCMNCPair();
      tempVar3.mcc_mnc.mcc = new TBCDString3("640");
      tempVar3.mcc_mnc.mnc = new TBCDString3("05a");
      tempVar3.tacs = new com.objsys.nas.TS24501IES.TrackingAreaCode[9];
   
      {
          byte testdata[] = { 
         (byte)0x69, (byte)0xe2, (byte)0x7e };
         tempVar3.tacs[0] = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar3.tacs[0].value = testdata;
      }
      {
          byte testdata[] = { 
         (byte)0xd9, (byte)0xae, (byte)0x68 };
         tempVar3.tacs[1] = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar3.tacs[1].value = testdata;
      }
      {
          byte testdata[] = { 
         (byte)0x40, (byte)0xc5, (byte)0x28 };
         tempVar3.tacs[2] = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar3.tacs[2].value = testdata;
      }
      {
          byte testdata[] = { 
         (byte)0xc4, (byte)0x80, (byte)0x51 };
         tempVar3.tacs[3] = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar3.tacs[3].value = testdata;
      }
      {
          byte testdata[] = { 
         (byte)0x01, (byte)0xfc, 0xa };
         tempVar3.tacs[4] = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar3.tacs[4].value = testdata;
      }
      {
          byte testdata[] = { 
         (byte)0xfa, (byte)0x0f, (byte)0x87 };
         tempVar3.tacs[5] = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar3.tacs[5].value = testdata;
      }
      {
          byte testdata[] = { 
         (byte)0xfd, (byte)0x4f, (byte)0xe1 };
         tempVar3.tacs[6] = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar3.tacs[6].value = testdata;
      }
      {
          byte testdata[] = { 
         (byte)0xdf, (byte)0xa3, 0x1 };
         tempVar3.tacs[7] = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar3.tacs[7].value = testdata;
      }
      {
          byte testdata[] = { 
         (byte)0xf3, (byte)0x8e, (byte)0xe9 };
         tempVar3.tacs[8] = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar3.tacs[8].value = testdata;
      }
      pvalue.allowedNSSAI = new NSSAI();
      pvalue.allowedNSSAI.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.allowedNSSAI.contents = new SNSSAI[1];
      pvalue.allowedNSSAI.contents[0] = new SNSSAI();
      pvalue.allowedNSSAI.contents[0].length = new Asn1Integer(4);
      pvalue.allowedNSSAI.contents[0].sst = new SST(122);
      pvalue.allowedNSSAI.contents[0].sd = new SD(1619282);
      {
          byte testdata[] = { 
         (byte)0x10 };
         pvalue.allowedNSSAI.contents[0].mappedSST = new Asn1OctetString(testdata);
      }
      {
          byte testdata[] = { 
         (byte)0xc1, (byte)0x44, (byte)0xaf };
         pvalue.allowedNSSAI.contents[0].mappedSD = new Asn1OctetString(testdata);
      }
      pvalue.fullNetworkName = new NetworkName();
      pvalue.fullNetworkName.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.fullNetworkName.ext = new Asn1Boolean(true);
      pvalue.fullNetworkName.codingScheme = NetworkName_codingScheme.callBcastData();
      pvalue.fullNetworkName.addCI = new Asn1Boolean(false);
      String text = "Email: info@obj-sys.com;Code{123}";
      pvalue.fullNetworkName.numSpareBitsInLastOct = new Asn1Integer(GSMStringUtil.unusedBits(text));
      pvalue.fullNetworkName.textString = new NetworkName_textString();
      GSMString tempVar4 = new GSMString(text);
      pvalue.fullNetworkName.textString.set_callBcastData(tempVar4);

      pvalue.localTZ = new TimeZone(105);
      pvalue.univAndLocalTZ = new TimeZoneAndTime();
      pvalue.univAndLocalTZ.year = new Asn1Integer(23);
      pvalue.univAndLocalTZ.month = new Asn1Integer(10);
      pvalue.univAndLocalTZ.day = new Asn1Integer(30);
      pvalue.univAndLocalTZ.hour = new Asn1Integer(12);
      pvalue.univAndLocalTZ.minute = new Asn1Integer(10);
      pvalue.univAndLocalTZ.second = new Asn1Integer(17);
      pvalue.univAndLocalTZ.timezone = new Asn1Integer(5);
      pvalue.dst = new DaylightSavingTime();
      pvalue.dst.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.dst.dst = DaylightSavingTime_dst.dstNoAdjust();
      pvalue.micoInd = new MICOIndication();
      pvalue.micoInd.raai = new Asn1Boolean(true);
      pvalue.micoInd.sprti = new Asn1Boolean(false);
      pvalue.rejectedNSSAI = new RejectedNSSAIList();
      pvalue.rejectedNSSAI.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.rejectedNSSAI.rejectedNSSAI = new RejectedNSSAI[1];
      pvalue.rejectedNSSAI.rejectedNSSAI[0] = new RejectedNSSAI();
      pvalue.rejectedNSSAI.rejectedNSSAI[0].length = new Asn1Integer(4);
      pvalue.rejectedNSSAI.rejectedNSSAI[0].cause = RejectedNSSAI_cause.unavailInCurrRegisArea();
      pvalue.rejectedNSSAI.rejectedNSSAI[0].sst = new SST(153);
      pvalue.rejectedNSSAI.rejectedNSSAI[0].sd = new SD(7049671);
      pvalue.mV16ExtPresent = true;
      pvalue.regResult = new RegistrationResult();
      pvalue.regResult.disasterRegisterValue = new Asn1Boolean(false);
      pvalue.regResult.emergencyRegistered = new Asn1Boolean(true);
      pvalue.regResult.nssaa = new Asn1Boolean(false);
      pvalue.regResult.smsAllowed = new Asn1Boolean(false);
      pvalue.regResult.regResult = new Asn1Integer(3);

      pvalue.additionalConfigIndication = new AddlConfigIndication();
      pvalue.additionalConfigIndication.scmr = new Asn1Boolean(true);

      pvalue.mV17ExtPresent = true;
      pvalue.disasterCondPLMNs = new DisasterConditionPLMNs();
      pvalue.disasterCondPLMNs.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.disasterCondPLMNs.plmnIds = new MCCMNCPair[2];
      pvalue.disasterCondPLMNs.plmnIds[0] = new MCCMNCPair();
      pvalue.disasterCondPLMNs.plmnIds[0].mcc = new TBCDString3("123");
      pvalue.disasterCondPLMNs.plmnIds[0].mnc = new TBCDString3("456");
      pvalue.disasterCondPLMNs.plmnIds[1] = new MCCMNCPair();
      pvalue.disasterCondPLMNs.plmnIds[1].mcc = new TBCDString3("789");
      pvalue.disasterCondPLMNs.plmnIds[1].mnc = new TBCDString3("000");

      pvalue.nsagInfo = new NSAGInformation();
      pvalue.nsagInfo.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.nsagInfo.nsagEntries = new NSAGEntry[1];
      pvalue.nsagInfo.nsagEntries[0] = new NSAGEntry();
      pvalue.nsagInfo.nsagEntries[0].length = new Asn1Integer(0); /* length will be calculated */
      pvalue.nsagInfo.nsagEntries[0].identifier = new Asn1Integer(11);
      pvalue.nsagInfo.nsagEntries[0].snssaiList = new NSSAI();
      pvalue.nsagInfo.nsagEntries[0].snssaiList.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.nsagInfo.nsagEntries[0].snssaiList.contents = new SNSSAI[1];
      pvalue.nsagInfo.nsagEntries[0].snssaiList.contents[0] = new SNSSAI();
      pvalue.nsagInfo.nsagEntries[0].snssaiList.contents[0].length = new Asn1Integer(0); /* length will be calculated */
      pvalue.nsagInfo.nsagEntries[0].snssaiList.contents[0].sst = new SST(111);
      pvalue.nsagInfo.nsagEntries[0].priority = new Asn1Integer(53);

      pvalue.priorityInd = new PriorityIndicator();
      pvalue.priorityInd.spare = new Asn1Integer(0);
      pvalue.priorityInd.mcsi = new Asn1Boolean(false);
      pvalue.priorityInd.mpsi = new Asn1Boolean(true);

      pvalue.mV18ExtPresent = true;
      pvalue.ranTiming = new RANTimingSynch();
      pvalue.ranTiming.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.ranTiming.recReq = new Asn1Boolean(true);

      pvalue.altNSSAI = new AlternativeNSSAI();
      pvalue.altNSSAI.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.altNSSAI.entries = new AltNSSAIEntry[1];
      pvalue.altNSSAI.entries[0] = new AltNSSAIEntry();
      pvalue.altNSSAI.entries[0].contentsLen = new Asn1Integer(0); /* length will be calculated */
      pvalue.altNSSAI.entries[0].replacedSnssai = new SNSSAI();
      pvalue.altNSSAI.entries[0].replacedSnssai.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.altNSSAI.entries[0].replacedSnssai.sst = new SST(44);
      pvalue.altNSSAI.entries[0].replacedSnssai.sd = new SD(16000);
      pvalue.altNSSAI.entries[0].replacedSnssai.mappedSST = new Asn1OctetString();
      pvalue.altNSSAI.entries[0].replacedSnssai.mappedSST.value = new byte[1];
      pvalue.altNSSAI.entries[0].replacedSnssai.mappedSST.value[0] = (byte)0x67;
      pvalue.altNSSAI.entries[0].altSnssai = new SNSSAI();
      pvalue.altNSSAI.entries[0].altSnssai.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.altNSSAI.entries[0].altSnssai.sst = new SST(22);

      pvalue.timeValidityInfo = new SNSSAITimeValidityInfo();
      pvalue.timeValidityInfo.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.timeValidityInfo.timeInfo = new TimeValidityInfo[1];
      pvalue.timeValidityInfo.timeInfo[0] = new TimeValidityInfo();
      pvalue.timeValidityInfo.timeInfo[0].length = new Asn1Integer(0); /* length will be calculated */
      pvalue.timeValidityInfo.timeInfo[0].snssai = new SNSSAI();
      pvalue.timeValidityInfo.timeInfo[0].snssai.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.timeValidityInfo.timeInfo[0].snssai.sst = new SST(33);
      pvalue.timeValidityInfo.timeInfo[0].timeValidityInfo = new PerTimeValidityInfo[1];
      pvalue.timeValidityInfo.timeInfo[0].timeValidityInfo[0] = new PerTimeValidityInfo();
      pvalue.timeValidityInfo.timeInfo[0].timeValidityInfo[0].length = new Asn1Integer(0); /* length will be calculated */
      pvalue.timeValidityInfo.timeInfo[0].timeValidityInfo[0].timeWindows = new TimeWindow[1];
      pvalue.timeValidityInfo.timeInfo[0].timeValidityInfo[0].timeWindows[0] = new TimeWindow();
      pvalue.timeValidityInfo.timeInfo[0].timeValidityInfo[0].timeWindows[0].startTime = new TimeWindow_startTime();
      pvalue.timeValidityInfo.timeInfo[0].timeValidityInfo[0].timeWindows[0].startTime.seconds = new Asn1Integer(10000);
      pvalue.timeValidityInfo.timeInfo[0].timeValidityInfo[0].timeWindows[0].startTime.fraction = new Asn1Integer(1234567);
      pvalue.timeValidityInfo.timeInfo[0].timeValidityInfo[0].timeWindows[0].stopTime = new TimeWindow_stopTime();
      pvalue.timeValidityInfo.timeInfo[0].timeValidityInfo[0].timeWindows[0].stopTime.seconds = new Asn1Integer(00000);
      pvalue.timeValidityInfo.timeInfo[0].timeValidityInfo[0].timeWindows[0].stopTime.fraction = new Asn1Integer(321);

      // Create a message buffer object and encode the record
      Asn1NasEncodeBuffer encodeBuffer = new Asn1NasEncodeBuffer();

      // Enable bit field tracing
      if (trace) {
         encodeBuffer.getTraceHandler().enable();
      }  

      try {

          pdu.encode (encodeBuffer);

          if (trace) {
              System.out.println ("Encoding was successful");
              System.out.println ("Hex dump of encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump:");
              encodeBuffer.binDump ("message");
          }

          // Write the encoded record to a file

          encodeBuffer.write (new FileOutputStream (filename));

          // Generate a dump file for comparisons

          encodeBuffer.hexDump 
              (new PrintStream (new FileOutputStream ("message.dmp")));
      }
      catch (Exception e) {
          if (trace) {
              System.out.println ("Hex dump of partially encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump of partially encoded record:");
              encodeBuffer.binDump ("message");
          }

          System.out.println (e.getMessage());
          e.printStackTrace();           
          System.exit(-1);
      }
   }
}
