import com.objsys.asn1j.runtime.*;
import java.io.*;

import com.objsys.nas.TS24501Msgs.*;
import com.objsys.nas.TS24501IES.*;
import com.objsys.nas.TS24301IES.*;
import com.objsys.nas.TS24008IES.*;

public class Writer {


   public static void main (String args[]) {
       String filename = new String ("message.dat");
       boolean trace = true;

      // Process command line arguments

      if (args.length > 0) {
         for (int i = 0; i < args.length; i++) {
            if (args[i].equals ("-v")) 
                Diag.instance().setEnabled (true);
            else if (args[i].equals ("-o")) 
                filename = new String (args[++i]);
            else if (args[i].equals ("-notrace")) trace = false;
            else {
                System.out.println ("usage: Writer [ -v ] [ -o <filename>");
                System.out.println ("   -v  verbose mode: print trace info");
                System.out.println ("   -o <filename>  " +
                                    "write encoded msg to <filename>");
                System.out.println ("   -notrace  do not display trace info");
                return;
            }
         }
      }

      // Create a data object and populate it with the data to be encoded
      com.objsys.nas.TS24501Msgs.PDU pdu = new PDU();
      com.objsys.nas.TS24501Msgs.EstablishAccept data = new EstablishAccept();
      com.objsys.nas.TS24501Msgs.EstablishAccept pvalue = data;
      pdu.protoDiscr = NAS5GProtoDiscr.sessMgmt5G();
      pdu.hdrData = new PDU_hdrData();
      PDU_hdrData_sm tempVar1 = new PDU_hdrData_sm();
      pdu.hdrData.set_sm(tempVar1);

      tempVar1.pduSessIdent = PDUSessionIdentity.pduId8();
      tempVar1.procTransIdent = new Asn1Integer(3);
      pdu.msgType = new _NAS5G_PROTOCOL_CLASS_msgType(_TS24501MsgsValues.st_EstablishAccept5G);
      pdu.data = pvalue;
      pvalue.pduSessionType = new PDUSessionType();
      pvalue.pduSessionType.sessionType = SessionType.st_ipv4v6();
      pvalue.sscMode = new SSCMode();
      pvalue.sscMode.sscMode = SSCModeValue.ssc_mode3();
      pvalue.qosRules = new QoSRules();
      pvalue.qosRules.length = new Asn1Integer(0); // Calculated automatically...
      pvalue.qosRules.rules = new QoSRule[2];
      pvalue.qosRules.rules[0] = new QoSRule();
      pvalue.qosRules.rules[0].ruleId = new Asn1Integer(6);
      pvalue.qosRules.rules[0].ruleLen = new Asn1Integer(0); // Calculated automatically...
      pvalue.qosRules.rules[0].ruleOpCode = RuleOpCodes.modifyAndDelete();
      pvalue.qosRules.rules[0].dqr = new Asn1Boolean(false);
      pvalue.qosRules.rules[0].numPacketFilters = new Asn1Integer(1);
      pvalue.qosRules.rules[0].packetFilterList = new QoSRule_packetFilterList();
      QoSRule_packetFilterList_modifyAndDelete tempVar2 = new QoSRule_packetFilterList_modifyAndDelete();
      pvalue.qosRules.rules[0].packetFilterList.set_modifyAndDelete(tempVar2);

      tempVar2.elements = new PFModifyAndDelete[1];
      tempVar2.elements[0] = new PFModifyAndDelete();
      tempVar2.elements[0].filterId = new Asn1Integer(3);
      pvalue.qosRules.rules[0].precedence = new Asn1Integer(8);
      pvalue.qosRules.rules[0].octet = new QoSRule_octet();
      pvalue.qosRules.rules[0].octet.segregation = new Asn1Boolean(false);
      pvalue.qosRules.rules[0].octet.flowId = new Asn1Integer(12);

      pvalue.qosRules.rules[1] = new QoSRule();
      pvalue.qosRules.rules[1].ruleId = new Asn1Integer(1);
      pvalue.qosRules.rules[1].ruleLen = new Asn1Integer(0); // Calculated automatically...
      pvalue.qosRules.rules[1].ruleOpCode = RuleOpCodes.createNew();
      pvalue.qosRules.rules[1].dqr = new Asn1Boolean(true);
      pvalue.qosRules.rules[1].numPacketFilters = new Asn1Integer(1);
      pvalue.qosRules.rules[1].packetFilterList = new QoSRule_packetFilterList();
      QoSRule_packetFilterList_createNew tempVar3 = new QoSRule_packetFilterList_createNew();
      pvalue.qosRules.rules[1].packetFilterList.set_createNew(tempVar3);
      tempVar3.elements = new PFCreateNew[1];
      tempVar3.elements[0] = new PFCreateNew();
      tempVar3.elements[0].filterDirection = new Asn1Integer(2);
      tempVar3.elements[0].filterId = new Asn1Integer(1);
      tempVar3.elements[0].filterContentLen = new Asn1Integer(0); // Calculated automatically...
      tempVar3.elements[0].filterContent = new PFComponent[2];
      tempVar3.elements[0].filterContent[0] = new PFComponent();      
      tempVar3.elements[0].filterContent[0].typeId = PacketFilterTypeId.matchAll();
      tempVar3.elements[0].filterContent[0].value = new PFComponent_value();
      tempVar3.elements[0].filterContent[0].value.set_matchAll();
      tempVar3.elements[0].filterContent[1] = new PFComponent();
      tempVar3.elements[0].filterContent[1].typeId = PacketFilterTypeId.ipv4Remote();
      {
          byte testdata[] = { (byte)0x12, (byte)0x34, (byte)0x56, (byte)0x78, (byte)0x9a, (byte)0xbc, (byte)0xde, (byte)0xf0 };
         tempVar3.elements[0].filterContent[1].value = new PFComponent_value();
         Asn1OctetString tempVar4 = new Asn1OctetString(testdata);
         tempVar3.elements[0].filterContent[1].value.set_ipv4Remote(tempVar4);
      }
      pvalue.qosRules.rules[1].precedence = new Asn1Integer(254);
      pvalue.qosRules.rules[1].octet = new QoSRule_octet();
      pvalue.qosRules.rules[1].octet.segregation = new Asn1Boolean(false);
      pvalue.qosRules.rules[1].octet.flowId = new Asn1Integer(13);
      pvalue.sessionAMBR = new SessionAMBR();
      pvalue.sessionAMBR.unitAmbrDL = new Asn1Integer(5);
      pvalue.sessionAMBR.sessionAmbrDL = new Asn1Integer(220);
      pvalue.sessionAMBR.unitAmbrUL = new Asn1Integer(10);
      pvalue.sessionAMBR.sessionAmbrUL = new Asn1Integer(75);
      pvalue.cause = new SMCause(38);

      pvalue.pduAddress = new PDUAddress();
      pvalue.pduAddress.length = new Asn1Integer(6);
      pvalue.pduAddress.s16LLA = new Asn1Integer(1);
      pvalue.pduAddress.sessionType = PDUAddressValues.ipv6();
      pvalue.pduAddress.addressInfo = new PDUAddress_addressInfo();
      {
         byte testdata[] = { (byte)0xf1, (byte)0xb3, (byte)0xc2, (byte)0xa8, (byte)0xab, (byte)0xcd, (byte)0xef, (byte)0x00 };
         pvalue.pduAddress.addressInfo.set_addressInfoIpv6(new Asn1OctetString(testdata));
      }
      pvalue.pduAddress.smfIp6Addr = new PDUAddress_smfIp6Addr();
      {
         byte testdata[] = { (byte)0x01, (byte)0x23, (byte)0x45, (byte)0x67, (byte)0x89, (byte)0xab, (byte)0xcd, (byte)0xef };
         pvalue.pduAddress.smfIp6Addr.set_present(new Asn1OctetString(testdata));
      }

      pvalue.alwaysOnPDUSession = new AlwaysOnPDUSessionInd();
      pvalue.alwaysOnPDUSession.apsi = new Asn1Boolean(true);
      pvalue.qosFlowDesr = new QOSFlowDescriptions();
      pvalue.qosFlowDesr.length = new Asn1Integer(0); // Calculated automatically...
      pvalue.qosFlowDesr.qosFlowDesr = new QOSFlowDescription[1];
      pvalue.qosFlowDesr.qosFlowDesr[0] = new QOSFlowDescription();
      pvalue.qosFlowDesr.qosFlowDesr[0].qfi = new Asn1Integer(20);
      pvalue.qosFlowDesr.qosFlowDesr[0].opCode = FlowOpCodes.flowModify();
      pvalue.qosFlowDesr.qosFlowDesr[0].eBit = new Asn1Boolean(false);
      pvalue.qosFlowDesr.qosFlowDesr[0].numParams = new Asn1Integer(2);
      pvalue.qosFlowDesr.qosFlowDesr[0].paramsList = new Parameter[2];
      pvalue.qosFlowDesr.qosFlowDesr[0].paramsList[0] = new Parameter();
      pvalue.qosFlowDesr.qosFlowDesr[0].paramsList[0].id = ParameterId.fiveQI();
      pvalue.qosFlowDesr.qosFlowDesr[0].paramsList[0].content = new Parameter_content();
      pvalue.qosFlowDesr.qosFlowDesr[0].paramsList[0].content.set_fiveQI(new Asn1Integer(7));
      pvalue.qosFlowDesr.qosFlowDesr[0].paramsList[1] = new Parameter();
      pvalue.qosFlowDesr.qosFlowDesr[0].paramsList[1].id = ParameterId.epsBearerIdent();
      pvalue.qosFlowDesr.qosFlowDesr[0].paramsList[1].content = new Parameter_content();
      { 
         Parameter_content_epsBearerIdent ebi = new Parameter_content_epsBearerIdent();
         ebi.value = new Asn1Integer(6);
         ebi.spare = new Asn1Integer(0);
         pvalue.qosFlowDesr.qosFlowDesr[0].paramsList[1].content.set_epsBearerIdent(ebi);
      }

      pvalue.extProtoCfgOpts = new ExtProtoConfigOptions();
      pvalue.extProtoCfgOpts.octet4 = new ExtProtoConfigOptions_octet4();
      pvalue.extProtoCfgOpts.octet4.configProtocol = new Asn1Integer(0);

      pvalue.mV16ExtPresent = true;

      pvalue.smNetFeatureSupport = new SMNetworkFeatureSupport();
      pvalue.smNetFeatureSupport.naps = new Asn1Boolean(false);
      pvalue.smNetFeatureSupport.eptS1 = new Asn1Boolean(true);

      pvalue.servingPLMNRateCtrl = new ServPLMNRateCtrl();
      {
         byte testdata[] = { (byte)0x1f, (byte)0x2e };
         pvalue.servingPLMNRateCtrl.value = testdata;
      }

      pvalue.atsssContainer = new ATSSSContainer();
      pvalue.atsssContainer.length = new Asn1Integer(0); // Calculated automatically...
      pvalue.atsssContainer.contents = new ATSSSParamList[1];
      pvalue.atsssContainer.contents[0] = new ATSSSParamList();
      pvalue.atsssContainer.contents[0].paramId = new Asn1Integer(2);
      pvalue.atsssContainer.contents[0].length = new Asn1Integer(0); // Calculated automatically...
      pvalue.atsssContainer.contents[0].contents = new ATSSSParamList_contents();
      NetworkSteeringInfo tempVar5 = new NetworkSteeringInfo();
      tempVar5.client3GAddrType = new Asn1Integer(1);
      tempVar5.client3GAddr = new NetworkSteeringInfo_client3GAddr();
      {
         byte testdata[] = { (byte)0xab, (byte)0xcd, (byte)0xef, (byte)0x12 };
         tempVar5.client3GAddr.set_ipv4(new Asn1OctetString(testdata));
      }
      tempVar5.clientNon3GAddrType = new Asn1Integer(1);
      tempVar5.clientNon3GAddr = new NetworkSteeringInfo_clientNon3GAddr();
      {
         byte testdata[] = { (byte)0x34, (byte)0x56, (byte)0x78, (byte)0x90 };
         tempVar5.clientNon3GAddr.set_ipv4(new Asn1OctetString(testdata));
      }
      tempVar5.proxyLen = new Asn1Integer(0); // Calculated automatically...
      tempVar5.proxyValues = new ProxyInfo[1];
      tempVar5.proxyValues[0] = new ProxyInfo();
      tempVar5.proxyValues[0].addrType = new Asn1Integer(1);
      tempVar5.proxyValues[0].address = new ProxyInfo_address();
      {
         byte testdata[] = { (byte)0x11, (byte)0x44, (byte)0x99, (byte)0xbb };
         tempVar5.proxyValues[0].address.set_ipv4(new Asn1OctetString(testdata));
      }
      tempVar5.proxyValues[0].port = new Asn1Integer(55555);
      tempVar5.proxyValues[0].proxyType = new Asn1Integer(1);
      pvalue.atsssContainer.contents[0].contents.set_mptcpSteering(tempVar5);

      pvalue.ctrlPlaneOnlyIndication = new ControlPlaneIndication();
      pvalue.ctrlPlaneOnlyIndication.cpoi = new Asn1Boolean(true);

      // Create a message buffer object and encode the record
      Asn1NasEncodeBuffer encodeBuffer = new Asn1NasEncodeBuffer();

      pvalue.mV18ExtPresent = true;
      pvalue.n3qai = new N3QAI();
      pvalue.n3qai.length = new Asn1Integer(0); // Calculated automatically...
      pvalue.n3qai.n3qais = new N3QAIList[1];
      pvalue.n3qai.n3qais[0] = new N3QAIList();
      pvalue.n3qai.n3qais[0].numQFIs = new Asn1Integer(0);
      pvalue.n3qai.n3qais[0].numParams = new Asn1Integer(1);
      pvalue.n3qai.n3qais[0].paramsList = new N3QAIParam[1];
      pvalue.n3qai.n3qais[0].paramsList[0] = new N3QAIParam();
      pvalue.n3qai.n3qais[0].paramsList[0].paramId = new Asn1Integer(10);
      pvalue.n3qai.n3qais[0].paramsList[0].length = new Asn1Integer(0); // Calculated automatically...
      pvalue.n3qai.n3qais[0].paramsList[0].contents = new N3QAIParam_contents();
      AdditionalQoSInfo tempVar6 = new AdditionalQoSInfo();
      tempVar6.numParams = new Asn1Integer(1);
      tempVar6.paramsList = new AddlQoSParamsList[1];
      tempVar6.paramsList[0] = new AddlQoSParamsList();
      tempVar6.paramsList[0].paramId = new Asn1Integer(8);
      tempVar6.paramsList[0].length = new Asn1Integer(0); // Calculated automatically...
      tempVar6.paramsList[0].contents = new AddlQoSParamsList_contents();
      {
         byte testdata[] = { (byte)0xab, (byte)0xba };
         tempVar6.paramsList[0].contents.set_maxPktLossRateUL(new Asn1OctetString(testdata));
      }
      pvalue.n3qai.n3qais[0].paramsList[0].contents.set_maxPktLossRateUL(tempVar6);

      // Enable bit field tracing
      if (trace) {
         encodeBuffer.getTraceHandler().enable();
      }  

      try {

          pdu.encode (encodeBuffer);

          if (trace) {
              System.out.println ("Encoding was successful");
              System.out.println ("Hex dump of encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump:");
              encodeBuffer.binDump ("message");
          }

          // Write the encoded record to a file

          encodeBuffer.write (new FileOutputStream (filename));

          // Generate a dump file for comparisons

          encodeBuffer.hexDump 
              (new PrintStream (new FileOutputStream ("message.dmp")));
      }
      catch (Exception e) {
          if (trace) {
              System.out.println ("Hex dump of partially encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump of partially encoded record:");
              encodeBuffer.binDump ("message");
          }

          System.out.println (e.getMessage());
          e.printStackTrace();           
          System.exit(-1);
      }
   }
}
