import com.objsys.asn1j.runtime.*;
import java.io.*;

import com.objsys.nas.TS24501Msgs.*;
import com.objsys.nas.TS24501IES.*;
import com.objsys.nas.TS24301IES.*;
import com.objsys.nas.TS24008IES.*;

public class Writer {


   public static void main (String args[]) {
       String filename = new String ("message.dat");
       boolean trace = true;

      // Process command line arguments

      if (args.length > 0) {
         for (int i = 0; i < args.length; i++) {
            if (args[i].equals ("-v")) 
                Diag.instance().setEnabled (true);
            else if (args[i].equals ("-o")) 
                filename = new String (args[++i]);
            else if (args[i].equals ("-notrace")) trace = false;
            else {
                System.out.println ("usage: Writer [ -v ] [ -o <filename>");
                System.out.println ("   -v  verbose mode: print trace info");
                System.out.println ("   -o <filename>  " +
                                    "write encoded msg to <filename>");
                System.out.println ("   -notrace  do not display trace info");
                return;
            }
         }
      }

      // Create a data object and populate it with the data to be encoded
      com.objsys.nas.TS24501Msgs.PDU pdu = new PDU();
      com.objsys.nas.TS24501Msgs.EstablishRequest data = new EstablishRequest();
      com.objsys.nas.TS24501Msgs.EstablishRequest pvalue = data;

      /* Populate data structure */
      pdu.protoDiscr = NAS5GProtoDiscr.sessMgmt5G();
      pdu.hdrData = new PDU_hdrData();
      PDU_hdrData_sm tempVar1 = new PDU_hdrData_sm();
      pdu.hdrData.set_sm(tempVar1);

      tempVar1.pduSessIdent = PDUSessionIdentity.pduId8();
      tempVar1.procTransIdent = new Asn1Integer(3);
      pdu.msgType = new _NAS5G_PROTOCOL_CLASS_msgType(_TS24501MsgsValues.st_EstablishRequest5G);
      pdu.data = pvalue;
      pvalue.integProtMaxRate = new IntegrityProtMaxDataRate();
      pvalue.integProtMaxRate.maxUEDataRateUplink = new Asn1Integer(0);
      pvalue.integProtMaxRate.maxUEDataRateDownlink = new Asn1Integer(255);
      pvalue.pduSessionType = new PDUSessionType();
      pvalue.pduSessionType.sessionType = SessionType.st_ipv4v6();
      pvalue.sscMode = new SSCMode();
      pvalue.sscMode.sscMode = SSCModeValue.ssc_mode3();
      pvalue.capability = new SMCapability();
      pvalue.capability.length = new Asn1Integer(0); /* Calculated automatically */
      pvalue.capability.tpmic = new Asn1Boolean(true);
      pvalue.capability.atsll = new Asn1Integer(2);
      pvalue.capability.epts1 = new Asn1Boolean(false);
      pvalue.capability.mh6Pdu = new Asn1Boolean(true);
      pvalue.capability.rqos = new Asn1Boolean(false);
      pvalue.capability.octet4 = new SMCapability_octet4();
      pvalue.capability.octet4.sdnaepc = new Asn1Boolean(false);
      pvalue.capability.octet4.apmqf = new Asn1Boolean(true);
      pvalue.maxPktFilters = new MaxSupportedPacketFilters();
      pvalue.maxPktFilters.maxFilters = new Asn1Integer(185);
      pvalue.extProtoCfgOpts = new ExtProtoConfigOptions();
      pvalue.extProtoCfgOpts.octet4 = new ExtProtoConfigOptions_octet4();
      pvalue.extProtoCfgOpts.octet4.configProtocol = new Asn1Integer(0);
      pvalue.mV16ExtPresent = true;
      pvalue.headerCompressionCfg = new HdrCompressConfig();
      pvalue.headerCompressionCfg.length = new Asn1Integer(0);
      pvalue.headerCompressionCfg.profile104 = new Asn1Boolean(true);
      pvalue.headerCompressionCfg.profile103 = new Asn1Boolean(false);
      pvalue.headerCompressionCfg.profile102 = new Asn1Boolean(true);
      pvalue.headerCompressionCfg.profile006 = new Asn1Boolean(false);
      pvalue.headerCompressionCfg.profile004 = new Asn1Boolean(true);
      pvalue.headerCompressionCfg.profile003 = new Asn1Boolean(false);
      pvalue.headerCompressionCfg.profile002 = new Asn1Boolean(true);
      pvalue.headerCompressionCfg.maxCID = new Asn1OctetString();
      pvalue.headerCompressionCfg.maxCID.value = new byte[2];
      pvalue.headerCompressionCfg.maxCID.value[0] = (byte)0xef;
      pvalue.headerCompressionCfg.maxCID.value[1] = (byte)0x01;
      pvalue.headerCompressionCfg.addlSetupType = HdrCompressCtxtParams.tcp_ip_6();
      pvalue.headerCompressionCfg.addlSetupContainer = new Asn1OctetString();
      {
          byte testdata[] = { (byte)0x34 };
         pvalue.headerCompressionCfg.addlSetupContainer.value = testdata;
      }
      pvalue.dsttPortMacAddr = new DSTTEthMACAddr();
      pvalue.dsttPortMacAddr.length = new Asn1Integer(0); /* Calculated automatically */
      pvalue.dsttPortMacAddr.contents = new Asn1OctetString();
      pvalue.dsttPortMacAddr.contents.value = new byte[6];
      pvalue.dsttPortMacAddr.contents.value[0] = (byte)0xab;
      pvalue.dsttPortMacAddr.contents.value[1] = (byte)0xcd;
      pvalue.dsttPortMacAddr.contents.value[2] = (byte)0x23;
      pvalue.dsttPortMacAddr.contents.value[3] = (byte)0x45;
      pvalue.dsttPortMacAddr.contents.value[4] = (byte)0x67;
      pvalue.dsttPortMacAddr.contents.value[5] = (byte)0x89;
      pvalue.portMgmtInfoContainer = new PortMgmtInfoContainer();
      pvalue.portMgmtInfoContainer.length = new Asn1Integer(0);  /* Calculated automatically */
      pvalue.portMgmtInfoContainer.container = new Asn1OctetString();
      {
          byte testdata[] = { (byte)0xff };
         pvalue.portMgmtInfoContainer.container.value = testdata;
      }

      pvalue.mV17ExtPresent = true;
      pvalue.sessionPairId = new PDUSessionPairId();
      pvalue.sessionPairId.length = new Asn1Integer(0); /* Calculated automatically */
      pvalue.sessionPairId.id = com.objsys.nas.TS24501IES.PDUPairIds.pairId4();

      pvalue.rsn = new RSN();
      pvalue.rsn.length = new Asn1Integer(0); /* Calculated automatically */
      pvalue.rsn.rsn = new Asn1Integer(53);

      // Create a message buffer object and encode the record
      Asn1NasEncodeBuffer encodeBuffer = new Asn1NasEncodeBuffer();

      // Enable bit field tracing

      if (trace) {
         encodeBuffer.getTraceHandler().enable();
      }  

      try {

          pdu.encode (encodeBuffer);

          if (trace) {
              System.out.println ("Encoding was successful");
              System.out.println ("Hex dump of encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump:");
              encodeBuffer.binDump ("message");
          }

          // Write the encoded record to a file

          encodeBuffer.write (new FileOutputStream (filename));

          // Generate a dump file for comparisons

          encodeBuffer.hexDump 
              (new PrintStream (new FileOutputStream ("message.dmp")));
      }
      catch (Exception e) {
          if (trace) {
              System.out.println ("Hex dump of partially encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump of partially encoded record:");
              encodeBuffer.binDump ("message");
          }

          System.out.println (e.getMessage());
          e.printStackTrace();           
          System.exit(-1);
      }
   }
}
