import com.objsys.asn1j.runtime.*;
import java.io.*;

import com.objsys.nas.TS24501Msgs.*;
import com.objsys.nas.TS24501IES.*;
import com.objsys.nas.TS24301IES.*;
import com.objsys.nas.TS24008IES.*;

public class Writer {


   public static void main (String args[]) {
       String filename = new String ("message.dat");
       boolean trace = true;

      // Process command line arguments

      if (args.length > 0) {
         for (int i = 0; i < args.length; i++) {
            if (args[i].equals ("-v")) 
                Diag.instance().setEnabled (true);
            else if (args[i].equals ("-o")) 
                filename = new String (args[++i]);
            else if (args[i].equals ("-notrace")) trace = false;
            else {
                System.out.println ("usage: Writer [ -v ] [ -o <filename>");
                System.out.println ("   -v  verbose mode: print trace info");
                System.out.println ("   -o <filename>  " +
                                    "write encoded msg to <filename>");
                System.out.println ("   -notrace  do not display trace info");
                return;
            }
         }
      }

      // Create a data object and populate it with the data to be encoded
      com.objsys.nas.TS24501Msgs.PDU pdu = new PDU();
      com.objsys.nas.TS24501Msgs.ModifyCmd data = new ModifyCmd();
      com.objsys.nas.TS24501Msgs.ModifyCmd pvalue = data;

      /* Populate data structure */
      pdu.protoDiscr = NAS5GProtoDiscr.sessMgmt5G();
      pdu.hdrData = new PDU_hdrData();
      PDU_hdrData_sm tempVar1 = new PDU_hdrData_sm();
      pdu.hdrData.set_sm(tempVar1);

      tempVar1.pduSessIdent = PDUSessionIdentity.pduId2();
      tempVar1.procTransIdent = new Asn1Integer(145);
      pdu.msgType = new _NAS5G_PROTOCOL_CLASS_msgType(_TS24501MsgsValues.st_ModifyCmd5G);
      pdu.data = pvalue;

//      pvalue.cause = not_null_value;
      pvalue.cause = new SMCause(27);

      pvalue.sessionAMBR = new SessionAMBR();
      pvalue.sessionAMBR.unitAmbrDL = new Asn1Integer(16);
      pvalue.sessionAMBR.sessionAmbrDL = new Asn1Integer(233);
      pvalue.sessionAMBR.unitAmbrUL = new Asn1Integer(8);
      pvalue.sessionAMBR.sessionAmbrUL = new Asn1Integer(21);

      pvalue.rqTimer = new GPRSTimer();
      pvalue.rqTimer.unit = new Asn1Integer(2);
      pvalue.rqTimer.timerValue = new Asn1Integer(19);

      pvalue.extProtoCfgOpts = new ExtProtoConfigOptions();
      pvalue.extProtoCfgOpts.octet4 = new ExtProtoConfigOptions_octet4();
      pvalue.extProtoCfgOpts.octet4.configProtocol = new Asn1Integer(0);

      pvalue.mV17ExtPresent = true;
      pvalue.recvMBSContainer = new ReceivedMBSContainer();
      pvalue.recvMBSContainer.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.recvMBSContainer.receivedInfo = new ReceivedMBSInfo[1];
      pvalue.recvMBSContainer.receivedInfo[0] = new ReceivedMBSInfo();
      pvalue.recvMBSContainer.receivedInfo[0].rejectionCause = new Asn1Integer(4);
      pvalue.recvMBSContainer.receivedInfo[0].msai = MSAITypes.notIncluded();
      pvalue.recvMBSContainer.receivedInfo[0].md = new Asn1Integer(3);
      pvalue.recvMBSContainer.receivedInfo[0].ipat = new Asn1Boolean(false);
      pvalue.recvMBSContainer.receivedInfo[0].msci = new Asn1Integer(1);
      pvalue.recvMBSContainer.receivedInfo[0].mti = MTITypes.startTime();
      pvalue.recvMBSContainer.receivedInfo[0].ipae = new Asn1Integer(1);
      pvalue.recvMBSContainer.receivedInfo[0].tmgi = new com.objsys.nas.TS24008IES.TMGI();
      {
         byte testdata[] = { (byte)0xaa, (byte)0xbb, (byte)0xcc };
         pvalue.recvMBSContainer.receivedInfo[0].tmgi.mbmsServiceID = new Asn1OctetString(testdata);
      }                         

      pvalue.recvMBSContainer.receivedInfo[0].tmgi.mcc_mnc = new MCCMNCPair();
      pvalue.recvMBSContainer.receivedInfo[0].tmgi.mcc_mnc.mcc = new TBCDString3("730");
      pvalue.recvMBSContainer.receivedInfo[0].tmgi.mcc_mnc.mnc = new TBCDString3("321");
      pvalue.recvMBSContainer.receivedInfo[0].ipAddrInfo = new ReceivedMBSInfo_ipAddrInfo();
      ReceivedMBSInfo_ipAddrInfo_included tempVar2 = new ReceivedMBSInfo_ipAddrInfo_included();
      pvalue.recvMBSContainer.receivedInfo[0].ipAddrInfo.set_included(tempVar2);
      {
         byte testdata[] = { (byte)0x54, (byte)0x87, (byte)0x31, (byte)0xd8 };
         tempVar2.srcAddrInfo = new Asn1OctetString(testdata);
      }
      {
         byte testdata[] = { (byte)0x7e, (byte)0x1a, (byte)0x44, (byte)0xf9 };
         tempVar2.destAddrInfo = new Asn1OctetString(testdata);
      }

      pvalue.recvMBSContainer.receivedInfo[0].serviceArea = new ReceivedMBSInfo_serviceArea();
      pvalue.recvMBSContainer.receivedInfo[0].serviceArea.set_notIncluded();

      pvalue.recvMBSContainer.receivedInfo[0].timer = new ReceivedMBSInfo_timer();
      TimeZoneAndTime tempVar3 = new TimeZoneAndTime();
      pvalue.recvMBSContainer.receivedInfo[0].timer.set_startTime(tempVar3);
      tempVar3.year = new Asn1Integer(22);
      tempVar3.month = new Asn1Integer(2);
      tempVar3.day = new Asn1Integer(18);
      tempVar3.hour = new Asn1Integer(14);
      tempVar3.minute = new Asn1Integer(30);
      tempVar3.second = new Asn1Integer(30);
      tempVar3.timezone = new Asn1Integer(0);

      pvalue.recvMBSContainer.receivedInfo[0].securityContainer = new ReceivedMBSInfo_securityContainer();
      ReceivedMBSInfo_securityContainer_included tempVar4 = new ReceivedMBSInfo_securityContainer_included();
      pvalue.recvMBSContainer.receivedInfo[0].securityContainer.set_included(tempVar4);
      tempVar4.numKeySets = new Asn1Integer(1);
      tempVar4.keySetList = new MBSSecurityKeySet[1];
      tempVar4.keySetList[0] = new MBSSecurityKeySet();
      tempVar4.keySetList[0].spare = new Asn1Integer(0);
      tempVar4.keySetList[0].mtki = new Asn1Integer(1);
      tempVar4.keySetList[0].keyDomainId = new MCCMNCPair();
      tempVar4.keySetList[0].keyDomainId.mcc = new TBCDString3("410");
      tempVar4.keySetList[0].keyDomainId.mnc = new TBCDString3("01");
      {
         byte testdata[] = { (byte)0x01, (byte)0x23, (byte)0x45, (byte)0x67 };
         tempVar4.keySetList[0].mskId = new Asn1OctetString(testdata);
      }
      {
         byte testdata[] = { (byte)0x00, (byte)0x11, (byte)0x22, (byte)0x33, (byte)0x44, (byte)0x55, (byte)0x66,
                             (byte)0x77, (byte)0x88, (byte)0x99, (byte)0xaa, (byte)0xbb, (byte)0xcc, (byte)0xdd,
                             (byte)0xee, (byte)0xff };
         tempVar4.keySetList[0].msk = new Asn1OctetString(testdata);
      }
      MBSSecurityKeySet_mtkInfo_included tempVar5 = new MBSSecurityKeySet_mtkInfo_included();
      tempVar4.keySetList[0].mtkInfo = new MBSSecurityKeySet_mtkInfo();
      tempVar4.keySetList[0].mtkInfo.set_included(tempVar5);
      {
         byte testdata[] = { (byte)0x89, (byte)0xab };
         tempVar5.mtkId = new Asn1OctetString(testdata);
      }
      {
         byte testdata[] = { (byte)0xcd, (byte)0xef, (byte)0xfe, (byte)0xdc, (byte)0xba, (byte)0x98, (byte)0x76,
                             (byte)0x54, (byte)0x32, (byte)0x10, (byte)0x01, (byte)0x02, (byte)0x03, (byte)0x04,
                             (byte)0x05, (byte)0x06 };
         tempVar5.mtk = new Asn1OctetString(testdata);
      }

      // Create a message buffer object and encode the record

      Asn1NasEncodeBuffer encodeBuffer = new Asn1NasEncodeBuffer();

      // Enable bit field tracing

      if (trace) {
         encodeBuffer.getTraceHandler().enable();
      }  

      try {

          pdu.encode (encodeBuffer);

          if (trace) {
              System.out.println ("Encoding was successful");
              System.out.println ("Hex dump of encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump:");
              encodeBuffer.binDump ("message");
          }

          // Write the encoded record to a file

          encodeBuffer.write (new FileOutputStream (filename));

          // Generate a dump file for comparisons

          encodeBuffer.hexDump 
              (new PrintStream (new FileOutputStream ("message.dmp")));
      }
      catch (Exception e) {
          if (trace) {
              System.out.println ("Hex dump of partially encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump of partially encoded record:");
              encodeBuffer.binDump ("message");
          }

          System.out.println (e.getMessage());
          e.printStackTrace();           
          System.exit(-1);
      }
   }
}
