import com.objsys.asn1j.runtime.*;
import java.io.*;

import com.objsys.nas.TS24501Msgs.*;
import com.objsys.nas.TS24501IES.*;
import com.objsys.nas.TS24301IES.*;
import com.objsys.nas.TS24008IES.*;

public class Writer {


   public static void main (String args[]) {
       String filename = new String ("message.dat");
       boolean trace = true;

      // Process command line arguments

      if (args.length > 0) {
         for (int i = 0; i < args.length; i++) {
            if (args[i].equals ("-v")) 
                Diag.instance().setEnabled (true);
            else if (args[i].equals ("-o")) 
                filename = new String (args[++i]);
            else if (args[i].equals ("-notrace")) trace = false;
            else {
                System.out.println ("usage: Writer [ -v ] [ -o <filename>");
                System.out.println ("   -v  verbose mode: print trace info");
                System.out.println ("   -o <filename>  " +
                                    "write encoded msg to <filename>");
                System.out.println ("   -notrace  do not display trace info");
                return;
            }
         }
      }

      // Create a data object and populate it with the data to be encoded

      com.objsys.nas.TS24501Msgs.PDU pdu = new PDU();
      com.objsys.nas.TS24501Msgs.RegAccept data = new RegAccept();
      com.objsys.nas.TS24501Msgs.RegAccept pvalue = data;

      /* Populate data structure */

      pdu.protoDiscr = NAS5GProtoDiscr.mobMgmt5G();
      pdu.hdrData = new PDU_hdrData();
      PDU_hdrData_mm tempVar1 = new PDU_hdrData_mm();
      pdu.hdrData.set_mm(tempVar1);

      tempVar1.secHdrType = NAS5GSecHdrType.noSec();

      pdu.msgType = new _NAS5G_PROTOCOL_CLASS_msgType(_TS24501MsgsValues.mt_RegAccept5G);
      pdu.data = pvalue;

      pvalue.regResult = new RegistrationResult();
      pvalue.regResult.disasterRegisterValue = new Asn1Boolean(false);
      pvalue.regResult.emergencyRegistered = new Asn1Boolean(false);
      pvalue.regResult.nssaa = new Asn1Boolean(false);
      pvalue.regResult.smsAllowed = new Asn1Boolean(true);
      pvalue.regResult.regResult = new Asn1Integer(3);

      pvalue.guti = new com.objsys.nas.TS24501IES.MobileIdentity();
      MobileIdentity_GUTI tempVar2 = new MobileIdentity_GUTI();
      pvalue.guti.set_guti(tempVar2);

      tempVar2.mcc_mnc = new MCCMNCPair();
      tempVar2.mcc_mnc.mcc = new TBCDString3("294");
      tempVar2.mcc_mnc.mnc = new TBCDString3("01");
      tempVar2.amfRegionID = new Asn1Integer(23);
      tempVar2.amfSetID = new Asn1Integer(4);
      tempVar2.amfPointer = new Asn1Integer(10);
      {
          byte testdata[] = { 
         (byte)0x11, (byte)0x79, (byte)0x71, (byte)0x86 };
         tempVar2.tmsi = new Asn1OctetString(testdata);
      }

      pvalue.plmnList = new PLMNList();
      pvalue.plmnList.elements = new MCCMNCPair[1];
      pvalue.plmnList.elements[0] = new MCCMNCPair();
      pvalue.plmnList.elements[0].mcc = new TBCDString3("286");
      pvalue.plmnList.elements[0].mnc = new TBCDString3("03");

      pvalue.taiList = new com.objsys.nas.TS24501IES.TrackingAreaIdentList();
      pvalue.taiList.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.taiList.idents = new com.objsys.nas.TS24501IES.TrackingAreaIdentListItem[2];
      pvalue.taiList.idents[0] = new com.objsys.nas.TS24501IES.TrackingAreaIdentListItem();
      pvalue.taiList.idents[0].allowedType = new Asn1Boolean(false);
      pvalue.taiList.idents[0].typeOfList = new Asn1Integer(1);
      pvalue.taiList.idents[0].numElements = new Asn1Integer(0); /* = 1 element */
      pvalue.taiList.idents[0].elements = new com.objsys.nas.TS24501IES.TrackingAreaIdentListItem_elements();

      com.objsys.nas.TS24501IES.PartialTrkAreaIdent1 tempVar3A = new com.objsys.nas.TS24501IES.PartialTrkAreaIdent1();
      pvalue.taiList.idents[0].elements.set_partTrkIdentList1(tempVar3A);
      tempVar3A.mcc_mnc = new MCCMNCPair();
      tempVar3A.mcc_mnc.mcc = new TBCDString3("310");
      tempVar3A.mcc_mnc.mnc = new TBCDString3("26");                                                              
      
      {
          byte testdata[] = { (byte)0x84, (byte)0x68, (byte)0x83 };
         tempVar3A.tac = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar3A.tac.value = testdata;
      }

      pvalue.taiList.idents[1] = new com.objsys.nas.TS24501IES.TrackingAreaIdentListItem();
      pvalue.taiList.idents[1].allowedType = new Asn1Boolean(false);
      pvalue.taiList.idents[1].typeOfList = new Asn1Integer(2);
      pvalue.taiList.idents[1].numElements = new Asn1Integer(2);
      pvalue.taiList.idents[1].elements = new com.objsys.nas.TS24501IES.TrackingAreaIdentListItem_elements();
      com.objsys.nas.TS24501IES.PartialTrkAreaIdent2 tempVar4 = new com.objsys.nas.TS24501IES.PartialTrkAreaIdent2();
      pvalue.taiList.idents[1].elements.set_partTrkIdentList2(tempVar4);
      tempVar4.elements = new com.objsys.nas.TS24501IES.TrackingAreaIdent[3];
      tempVar4.elements[0] = new com.objsys.nas.TS24501IES.TrackingAreaIdent();
      tempVar4.elements[0].mcc_mnc = new MCCMNCPair();
      tempVar4.elements[0].mcc_mnc.mcc = new TBCDString3("123");
      tempVar4.elements[0].mcc_mnc.mnc = new TBCDString3("21");
                  
      {
          byte testdata[] = { (byte)0x01, (byte)0x23, (byte)0x45 };
         tempVar4.elements[0].tac = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar4.elements[0].tac.value = testdata;
      }
      tempVar4.elements[1] = new com.objsys.nas.TS24501IES.TrackingAreaIdent();
      tempVar4.elements[1].mcc_mnc = new MCCMNCPair();
      tempVar4.elements[1].mcc_mnc.mcc = new TBCDString3("456");
      tempVar4.elements[1].mcc_mnc.mnc = new TBCDString3("22");
                                                                                      
                  
      {
          byte testdata[] = { (byte)0x67, (byte)0x89, (byte)0xab };
         tempVar4.elements[1].tac = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar4.elements[1].tac.value = testdata;
      }
      tempVar4.elements[2] = new com.objsys.nas.TS24501IES.TrackingAreaIdent();
      tempVar4.elements[2].mcc_mnc = new MCCMNCPair();
      tempVar4.elements[2].mcc_mnc.mcc = new TBCDString3("789");             
      tempVar4.elements[2].mcc_mnc.mnc = new TBCDString3("33");
                  
      {
          byte testdata[] = { (byte)0xcd, (byte)0xef, (byte)0x00 };
         tempVar4.elements[2].tac = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar4.elements[2].tac.value = testdata;
      }

      pvalue.allowedNSSAI = new NSSAI();
      pvalue.allowedNSSAI.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.allowedNSSAI.contents = new SNSSAI[1];
      pvalue.allowedNSSAI.contents[0] = new SNSSAI();
      pvalue.allowedNSSAI.contents[0].length = new Asn1Integer(49);
      pvalue.allowedNSSAI.contents[0].sst = new SST(41);
      pvalue.allowedNSSAI.contents[0].sd = new SD(1639727);
      {
          byte testdata[] = { 
         (byte)0x65 };
         pvalue.allowedNSSAI.contents[0].mappedSST = new Asn1OctetString(testdata);
      }
      {
          byte testdata[] = { 
         (byte)0x8d, (byte)0x0b, (byte)0x76 };
         pvalue.allowedNSSAI.contents[0].mappedSD = new Asn1OctetString(testdata);
      }

      pvalue.netSupport = new NetworkFeatureSupport();
      pvalue.netSupport.length = new Asn1Integer(237);
      pvalue.netSupport.mpsInd = new Asn1Boolean(true);
      pvalue.netSupport.interNetworkWithoutN26Ind = new Asn1Boolean(true);
      pvalue.netSupport.emfInd = new Asn1Integer(2);
      pvalue.netSupport.emcInd = new Asn1Integer(1);
      pvalue.netSupport.imsVoPSN3GPPInd = new Asn1Boolean(true);
      pvalue.netSupport.imsVoPS3GPPInd = new Asn1Boolean(false);
      pvalue.netSupport.octet4 = new NetworkFeatureSupport_octet4();
      pvalue.netSupport.octet4.upCIoT = new Asn1Boolean(false);
      pvalue.netSupport.octet4.hcCpCIoT = new Asn1Boolean(false);
      pvalue.netSupport.octet4.n3Data = new Asn1Boolean(true);
      pvalue.netSupport.octet4.cpCIoT = new Asn1Boolean(true);
      pvalue.netSupport.octet4.restrictedEC = new Asn1Integer(1);
      pvalue.netSupport.octet4.mcsi = new Asn1Boolean(false);
      pvalue.netSupport.octet4.emcn3 = new Asn1Boolean(false);
      pvalue.netSupport.octet5 = new NetworkFeatureSupport_octet5();
      pvalue.netSupport.octet5.unper = new Asn1Boolean(false);
      pvalue.netSupport.octet5.pr = new Asn1Boolean(true);
      pvalue.netSupport.octet5.rpr = new Asn1Boolean(false);
      pvalue.netSupport.octet5.piv = new Asn1Boolean(false);
      pvalue.netSupport.octet5.ncr = new Asn1Boolean(true);
      pvalue.netSupport.octet5.ehcCpCIoT = new Asn1Boolean(true);
      pvalue.netSupport.octet5.atsInd = new Asn1Boolean(false);
      pvalue.netSupport.octet5.lcs = new Asn1Boolean(true);
      pvalue.netSupport.octet6 = new NetworkFeatureSupport_octet6();
      pvalue.netSupport.octet6.rslp = new Asn1Boolean(false);
      pvalue.netSupport.octet6.supl = new Asn1Boolean(false);
      pvalue.netSupport.octet6.lcsupp = new Asn1Boolean(false);
      pvalue.netSupport.octet6.naps = new Asn1Boolean(true);

      pvalue.sessionStat = new PDUSessionStatus();
      pvalue.sessionStat.length = new Asn1Integer(10);
      
      pvalue.sessionStat.psi_7 = new Asn1Boolean(true);
      pvalue.sessionStat.psi_2 = new Asn1Boolean(true);
      pvalue.sessionStat.psi_13 = new Asn1Boolean(true);
      pvalue.sessionStat.psi_0 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_1 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_3 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_4 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_5 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_6 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_8 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_9 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_10 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_11 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_12 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_14 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_15 = new Asn1Boolean(false);
               
      pvalue.reactivateRsltCause = new SessionReactivateCause();
      pvalue.reactivateRsltCause.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.reactivateRsltCause.reactivateCause = new ReactivateCause[1];
      pvalue.reactivateRsltCause.reactivateCause[0] = new ReactivateCause();
      pvalue.reactivateRsltCause.reactivateCause[0].sessionId = new Asn1Integer(30);
      pvalue.reactivateRsltCause.reactivateCause[0].cause = new MMCause(3);

      pvalue.micoInd = new MICOIndication(0, false, false);
      pvalue.micoInd.raai = new Asn1Boolean(false);

      pvalue.t3512 = new GPRSTimer3();
      pvalue.t3512.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.t3512.unit = GPRSTimer3_unit.valIncrMult10Mins();
      pvalue.t3512.timerValue = new Asn1Integer(12);

      pvalue.non3GPPDeregTimer = new GPRSTimer2();
      pvalue.non3GPPDeregTimer.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.non3GPPDeregTimer.value = new GPRSTimer();
      pvalue.non3GPPDeregTimer.value.unit = new Asn1Integer(2);
      pvalue.non3GPPDeregTimer.value.timerValue = new Asn1Integer(24);

      pvalue.emergencyNumList = new EmergencyNumberList();
      pvalue.emergencyNumList.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.emergencyNumList.numbers = new EmergencyNumberList_numbers();
      pvalue.emergencyNumList.numbers.elements = new EmergencyNumber[1];
      pvalue.emergencyNumList.numbers.elements[0] = new EmergencyNumber();
      pvalue.emergencyNumList.numbers.elements[0].length = new Asn1Integer(0); /* length will be calculated */
      pvalue.emergencyNumList.numbers.elements[0].spare = new Asn1Integer(0);
      pvalue.emergencyNumList.numbers.elements[0].catValue = new Asn1Integer(10);
      pvalue.emergencyNumList.numbers.elements[0].digits = new TBCDString("ca7201");

      pvalue.eapMessage = new EAPMessage();
      pvalue.eapMessage.length = new Asn1Integer(0); // Calculated automatically...
      pvalue.eapMessage.packetFormat = new EAPPacketFormat();
      pvalue.eapMessage.packetFormat.code = EAPFormatCode.request();
      pvalue.eapMessage.packetFormat.id = new Asn1Integer(11);
      pvalue.eapMessage.packetFormat.length = new Asn1Integer(8);
      pvalue.eapMessage.packetFormat.data = new Asn1OctetString();
      pvalue.eapMessage.packetFormat.data.value = new byte[4];
      pvalue.eapMessage.packetFormat.data.value[0] = (byte)0xb6;
      pvalue.eapMessage.packetFormat.data.value[1] = (byte)0xdd;
      pvalue.eapMessage.packetFormat.data.value[2] = (byte)0xc4;
      pvalue.eapMessage.packetFormat.data.value[3] = (byte)0x9c;

      pvalue.ueRadioCapIdDeletionIndication = new UERadioCapIdDeletionInd();
      pvalue.ueRadioCapIdDeletionIndication.deletionReq = new Asn1Integer(1);

      pvalue.mV16ExtPresent = true;
      pvalue.cipherKeyData = new CipheringKeyData();
      pvalue.cipherKeyData.length = new Asn1Integer(0);  // Calculated automatically...
      pvalue.cipherKeyData.dataSet = new CipheringKeyData_dataSet();
      pvalue.cipherKeyData.dataSet.elements = new com.objsys.nas.TS24501IES.CipherDataSet[1];
      pvalue.cipherKeyData.dataSet.elements[0] = new com.objsys.nas.TS24501IES.CipherDataSet();
      pvalue.cipherKeyData.dataSet.elements[0].cipherKey = new Asn1OctetString();
      pvalue.cipherKeyData.dataSet.elements[0].cipherKey.value = new byte[16];
      pvalue.cipherKeyData.dataSet.elements[0].cipherKey.value[0] = (byte)0x01;
      pvalue.cipherKeyData.dataSet.elements[0].c0Len = new Asn1Integer(6);
      pvalue.cipherKeyData.dataSet.elements[0].c0 = new Asn1OctetString("012345");
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB = new com.objsys.nas.TS24501IES.CipherDataSet_eutraPosSIB();
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet1 = new com.objsys.nas.TS24501IES.CipherDataSet_eutraPosSIB_octet1();
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet2 = new com.objsys.nas.TS24501IES.CipherDataSet_eutraPosSIB_octet2();
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet3 = new com.objsys.nas.TS24501IES.CipherDataSet_eutraPosSIB_octet3();
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet4 = new com.objsys.nas.TS24501IES.CipherDataSet_eutraPosSIB_octet4();
      
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet1.posSIBType1_1 = new Asn1Boolean(true);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet1.posSIBType1_6 = new Asn1Boolean(true);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet2.posSIBType2_3 = new Asn1Boolean(true);
      
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet1.posSIBType1_2 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet1.posSIBType1_3 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet1.posSIBType1_4 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet1.posSIBType1_5 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet1.posSIBType1_7 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet1.posSIBType1_8 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet2.posSIBType2_1 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet2.posSIBType2_2 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet2.posSIBType2_4 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet2.posSIBType2_5 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet2.posSIBType2_6 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet2.posSIBType2_7 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet2.posSIBType2_8 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet3.posSIBType2_9 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet3.posSIBType2_10 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet3.posSIBType2_11 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet3.posSIBType2_12 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet3.posSIBType2_13 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet3.posSIBType2_14 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet3.posSIBType2_15 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet3.posSIBType2_16 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet4.posSIBType2_17 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet4.posSIBType2_18 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet4.posSIBType2_19 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet4.posSIBType2_20 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet4.posSIBType2_21 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet4.posSIBType2_22 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet4.posSIBType2_23 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].eutraPosSIB.octet4.posSIBType2_24 = new Asn1Boolean(false);
      

      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB = new com.objsys.nas.TS24501IES.CipherDataSet_nrPosSIB();
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet1 = new com.objsys.nas.TS24501IES.CipherDataSet_nrPosSIB_octet1();
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet2 = new com.objsys.nas.TS24501IES.CipherDataSet_nrPosSIB_octet2();
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet3 = new com.objsys.nas.TS24501IES.CipherDataSet_nrPosSIB_octet3();
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet4 = new com.objsys.nas.TS24501IES.CipherDataSet_nrPosSIB_octet4();
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet5 = new com.objsys.nas.TS24501IES.CipherDataSet_nrPosSIB_octet5();
      
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet2.posSIBType2_8 = new Asn1Boolean(true);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet3.posSIBType2_13= new Asn1Boolean(true);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet4.posSIBType2_18 = new Asn1Boolean(true);      
      
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet1.posSIBType1_1 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet1.posSIBType1_2 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet1.posSIBType1_3 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet1.posSIBType1_4 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet1.posSIBType1_5 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet1.posSIBType1_6 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet1.posSIBType1_7 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet1.posSIBType1_8 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet2.posSIBType2_1 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet2.posSIBType2_2 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet2.posSIBType2_3 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet2.posSIBType2_4 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet2.posSIBType2_5 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet2.posSIBType2_6 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet2.posSIBType2_7 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet3.posSIBType2_9 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet3.posSIBType2_10 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet3.posSIBType2_11 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet3.posSIBType2_12 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet3.posSIBType2_14 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet3.posSIBType2_15 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet3.posSIBType2_16 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet4.posSIBType2_17 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet4.posSIBType2_19 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet4.posSIBType2_20 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet4.posSIBType2_21 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet4.posSIBType2_22 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet4.posSIBType2_23 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet4.posSIBType3_1 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet5.posSIBType4_1 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet5.posSIBType5_1 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet5.posSIBType6_1 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet5.posSIBType6_2 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet5.posSIBType6_3 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet5.posSIBType6_4 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet5.posSIBType6_5 = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].nrPosSIB.octet5.posSIBType6_6 = new Asn1Boolean(false);
           
      pvalue.cipherKeyData.dataSet.elements[0].validityStartTime = new TimeZoneAndTime();
      pvalue.cipherKeyData.dataSet.elements[0].validityStartTime.year = new Asn1Integer(20);
      pvalue.cipherKeyData.dataSet.elements[0].validityStartTime.month = new Asn1Integer(4);
      pvalue.cipherKeyData.dataSet.elements[0].validityStartTime.day = new Asn1Integer(1);
      pvalue.cipherKeyData.dataSet.elements[0].validityStartTime.hour = new Asn1Integer(3);
      pvalue.cipherKeyData.dataSet.elements[0].validityStartTime.minute = new Asn1Integer(30);
      pvalue.cipherKeyData.dataSet.elements[0].validityStartTime.second = new Asn1Integer(0);
      pvalue.cipherKeyData.dataSet.elements[0].validityStartTime.timezone = new Asn1Integer(0);
      pvalue.cipherKeyData.dataSet.elements[0].validityDuration = new Asn1Integer(500);
      pvalue.cipherKeyData.dataSet.elements[0].taiList = new com.objsys.nas.TS24501IES.TrackingAreaIdentList();
      pvalue.cipherKeyData.dataSet.elements[0].taiList.length = new Asn1Integer(0);  // Calculated automatically...
      pvalue.cipherKeyData.dataSet.elements[0].taiList.idents = new com.objsys.nas.TS24501IES.TrackingAreaIdentListItem[1];
      pvalue.cipherKeyData.dataSet.elements[0].taiList.idents[0] = new com.objsys.nas.TS24501IES.TrackingAreaIdentListItem();
      pvalue.cipherKeyData.dataSet.elements[0].taiList.idents[0].allowedType = new Asn1Boolean(false);
      pvalue.cipherKeyData.dataSet.elements[0].taiList.idents[0].typeOfList = new Asn1Integer(1);
      pvalue.cipherKeyData.dataSet.elements[0].taiList.idents[0].numElements = new Asn1Integer(12);
      pvalue.cipherKeyData.dataSet.elements[0].taiList.idents[0].elements = new com.objsys.nas.TS24501IES.TrackingAreaIdentListItem_elements();
      com.objsys.nas.TS24501IES.PartialTrkAreaIdent1 tempVar5 = new com.objsys.nas.TS24501IES.PartialTrkAreaIdent1();
              
      pvalue.cipherKeyData.dataSet.elements[0].taiList.idents[0].elements.set_partTrkIdentList1(tempVar5);

      tempVar5.mcc_mnc = new MCCMNCPair();
      tempVar5.mcc_mnc.mcc = new TBCDString3("640");
      tempVar5.mcc_mnc.mnc = new TBCDString3("05");
      {
          byte testdata[] = {  (byte)0x69, (byte)0xe2, (byte)0x7e };
         tempVar5.tac = new com.objsys.nas.TS24501IES.TrackingAreaCode();
         tempVar5.tac.value = testdata;
      }                         
 
      pvalue.cagInfoList = new CAGInfoList();
      pvalue.cagInfoList.length = new Asn1Integer(0);  // Calculated automatically...
      pvalue.cagInfoList.entries = new CAGEntry[1];
      pvalue.cagInfoList.entries[0] = new CAGEntry();
      pvalue.cagInfoList.entries[0].length = new Asn1Integer(4);
      pvalue.cagInfoList.entries[0].mcc_mnc = new MCCMNCPair();
      pvalue.cagInfoList.entries[0].mcc_mnc.mcc = new TBCDString3("410");
      pvalue.cagInfoList.entries[0].mcc_mnc.mnc = new TBCDString3("01");
      pvalue.cagInfoList.entries[0].cagOnly = new Asn1Boolean(true);

      pvalue.truncatedConfig = new TruncatedTMSIConfig();
      pvalue.truncatedConfig.truncatedAMFId = new Asn1Integer(5);
      pvalue.truncatedConfig.truncatedAMFPtr = new Asn1Integer(15);

      pvalue.mV17ExtPresent = true;
      pvalue.negotiatedPEIPSInfo = new PEIPSAssistanceInfo();
      pvalue.negotiatedPEIPSInfo.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.negotiatedPEIPSInfo.infoTypes = new PEIPSAssistInfoType[2];
      pvalue.negotiatedPEIPSInfo.infoTypes[0] = new PEIPSAssistInfoType();
      pvalue.negotiatedPEIPSInfo.infoTypes[0].type = PEIPSInfoTypes.pagingSubgroupId();
      pvalue.negotiatedPEIPSInfo.infoTypes[0].pagingSubgroupVal = new Asn1Integer(22);
      pvalue.negotiatedPEIPSInfo.infoTypes[1] = new PEIPSAssistInfoType();
      pvalue.negotiatedPEIPSInfo.infoTypes[1].type = PEIPSInfoTypes.pagingSubgroupId();
      pvalue.negotiatedPEIPSInfo.infoTypes[1].pagingSubgroupVal = new Asn1Integer(11);

      pvalue.nssrgInfo = new NSSRGInfo();
      pvalue.nssrgInfo.length = new Asn1Integer(0);  // Calculated automatically...
      pvalue.nssrgInfo.nssrgValues = new NSSRGValues[1];
      pvalue.nssrgInfo.nssrgValues[0] = new NSSRGValues();
      pvalue.nssrgInfo.nssrgValues[0].length = new Asn1Integer(0);
      pvalue.nssrgInfo.nssrgValues[0].snssai = new SNSSAI();
      pvalue.nssrgInfo.nssrgValues[0].snssai.length = new Asn1Integer(0);
      pvalue.nssrgInfo.nssrgValues[0].snssai.sst = new SST(250);

      pvalue.mV18ExtPresent = true;
      pvalue.equivalentSNPNs = new SNPNList();
      pvalue.equivalentSNPNs.length = new Asn1Integer(0);  // Calculated automatically...
      pvalue.equivalentSNPNs.ids = new SNPNId[1];
      pvalue.equivalentSNPNs.ids[0] = new SNPNId();
      pvalue.equivalentSNPNs.ids[0].mccmnc = new MCCMNCPair();
      pvalue.equivalentSNPNs.ids[0].mccmnc.mcc = new TBCDString3("410");
      pvalue.equivalentSNPNs.ids[0].mccmnc.mnc = new TBCDString3("01");
      pvalue.equivalentSNPNs.ids[0].nid = new NID();
      pvalue.equivalentSNPNs.ids[0].nid.nidDigit1 = new Asn1Integer(7);
      pvalue.equivalentSNPNs.ids[0].nid.assignMode = new Asn1Integer(0);
      pvalue.equivalentSNPNs.ids[0].nid.nidDigit3 = new Asn1Integer(5);
      pvalue.equivalentSNPNs.ids[0].nid.nidDigit2 = new Asn1Integer(4);
      pvalue.equivalentSNPNs.ids[0].nid.nidDigit5 = new Asn1Integer(3);
      pvalue.equivalentSNPNs.ids[0].nid.nidDigit4 = new Asn1Integer(2);
      pvalue.equivalentSNPNs.ids[0].nid.nidDigit7 = new Asn1Integer(1);
      pvalue.equivalentSNPNs.ids[0].nid.nidDigit6 = new Asn1Integer(15);
      pvalue.equivalentSNPNs.ids[0].nid.nidDigit9 = new Asn1Integer(13);
      pvalue.equivalentSNPNs.ids[0].nid.nidDigit8 = new Asn1Integer(11);
      pvalue.equivalentSNPNs.ids[0].nid.nidDigit10 = new Asn1Integer(9);

      pvalue.nid = new NetworkId();
      pvalue.nid.length = new Asn1Integer(0);  // Calculated automatically...
      pvalue.nid.nid = new NID();
      pvalue.nid.nid.nidDigit1 = new Asn1Integer(0);
      pvalue.nid.nid.assignMode = new Asn1Integer(1);
      pvalue.nid.nid.nidDigit3 = new Asn1Integer(2);
      pvalue.nid.nid.nidDigit2 = new Asn1Integer(3);
      pvalue.nid.nid.nidDigit5 = new Asn1Integer(4);
      pvalue.nid.nid.nidDigit4 = new Asn1Integer(5);
      pvalue.nid.nid.nidDigit7 = new Asn1Integer(6);
      pvalue.nid.nid.nidDigit6 = new Asn1Integer(7);
      pvalue.nid.nid.nidDigit9 = new Asn1Integer(8);
      pvalue.nid.nid.nidDigit8 = new Asn1Integer(9);
      pvalue.nid.nid.nidDigit10 = new Asn1Integer(10);

      // Create a message buffer object and encode the record
      Asn1NasEncodeBuffer encodeBuffer = new Asn1NasEncodeBuffer();

      // Enable bit field tracing
      if (trace) {
         encodeBuffer.getTraceHandler().enable();
      }  

      try {

          pdu.encode (encodeBuffer);

          if (trace) {
              System.out.println ("Encoding was successful");
              System.out.println ("Hex dump of encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump:");
              encodeBuffer.binDump ("message");
          }

          // Write the encoded record to a file

          encodeBuffer.write (new FileOutputStream (filename));

          // Generate a dump file for comparisons

          encodeBuffer.hexDump 
              (new PrintStream (new FileOutputStream ("message.dmp")));
      }
      catch (Exception e) {
          if (trace) {
              System.out.println ("Hex dump of partially encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump of partially encoded record:");
              encodeBuffer.binDump ("message");
          }

          System.out.println (e.getMessage());
          e.printStackTrace();           
          System.exit(-1);
      }
   }
}
