import com.objsys.asn1j.runtime.*;
import java.io.*;

import com.objsys.nas.TS24501Msgs.*;
import com.objsys.nas.TS24501IES.*;
import com.objsys.nas.TS24301IES.*;
import com.objsys.nas.TS24008IES.*;

public class Writer {


   public static void main (String args[]) {
       String filename = new String ("message.dat");
       boolean trace = true;

      // Process command line arguments

      if (args.length > 0) {
         for (int i = 0; i < args.length; i++) {
            if (args[i].equals ("-v")) 
                Diag.instance().setEnabled (true);
            else if (args[i].equals ("-o")) 
                filename = new String (args[++i]);
            else if (args[i].equals ("-notrace")) trace = false;
            else {
                System.out.println ("usage: Writer [ -v ] [ -o <filename>");
                System.out.println ("   -v  verbose mode: print trace info");
                System.out.println ("   -o <filename>  " +
                                    "write encoded msg to <filename>");
                System.out.println ("   -notrace  do not display trace info");
                return;
            }
         }
      }

      // Create a data object and populate it with the data to be encoded
      com.objsys.nas.TS24501Msgs.PDU pdu = new PDU();
      com.objsys.nas.TS24501Msgs.RegRequest data = new RegRequest();
      com.objsys.nas.TS24501Msgs.RegRequest pvalue = data;

      /* Populate data structure */

      pdu.protoDiscr = NAS5GProtoDiscr.mobMgmt5G();
      pdu.hdrData = new PDU_hdrData();
      PDU_hdrData_mm tempVar1 = new PDU_hdrData_mm();
      pdu.hdrData.set_mm(tempVar1);

      tempVar1.secHdrType = NAS5GSecHdrType.noSec();

      pdu.msgType = new _NAS5G_PROTOCOL_CLASS_msgType(_TS24501MsgsValues.mt_RegRequest5G);
      pdu.data = pvalue;

      pvalue.registrationType = new RegistrationType();
      pvalue.registrationType.forBit = new Asn1Boolean(true);
      pvalue.registrationType.regisType = RegistrationTypeValue.emergency();

      pvalue.nasKeySetIdent = new NASKeySetIdentifier();
      pvalue.nasKeySetIdent.tsc = new Asn1Boolean(false);
      pvalue.nasKeySetIdent.ident = new Asn1Integer(2);

      pvalue.mobileId = new com.objsys.nas.TS24501IES.MobileIdentity();
      pvalue.mobileId.set_none();
      pvalue.capability = new MMCapability(false, false, false, false, false, false, false, false);
      pvalue.capability.sgc = new Asn1Boolean(true);
      pvalue.capability.handoverSupported = new Asn1Boolean(true);
      pvalue.capability.s1Supported = new Asn1Boolean(true);
      pvalue.capability.octet4 = new MMCapability_octet4(false, false, false, false, false, false, false, false);
      pvalue.capability.octet4.v2xcnpc5 = new Asn1Boolean(true);
      pvalue.capability.octet4.v2xcepc5 = new Asn1Boolean(true);
      pvalue.capability.octet5 = new MMCapability_octet5(false, false, false, false, false, false, false, false);
      pvalue.capability.octet5.proSel2relay = new Asn1Boolean(true);
      pvalue.capability.octet5.proSedd = new Asn1Boolean(true);
      pvalue.capability.octet5.cag = new Asn1Boolean(true);
      pvalue.capability.octet6 = new MMCapability_octet6(false, false, false, false, false, false, false, false);
      pvalue.capability.octet6.rpr = new Asn1Boolean(true);
      pvalue.capability.octet6.nrpssi = new Asn1Boolean(true);
      pvalue.capability.octet6.proSel3rmt = new Asn1Boolean(true);
      pvalue.capability.octet6.proSel3relay = new Asn1Boolean(true);
      pvalue.capability.octet7 = new MMCapability_octet7(false, false, false, false, false, false, false, false);
      pvalue.capability.octet7.exCag = new Asn1Boolean(true);
      pvalue.capability.octet7.eventNotify = new Asn1Boolean(true);
      pvalue.capability.octet7.mint = new Asn1Boolean(true);
      pvalue.capability.octet8 = new MMCapability_octet8(false, false, false, false, false, false, false, false);
      pvalue.capability.octet8.nsr = new Asn1Boolean(true);
      pvalue.capability.octet8.ranTiming = new Asn1Boolean(true);
      pvalue.capability.octet8.rcman = new Asn1Boolean(true);
      pvalue.capability.octet9 = new MMCapability_octet9(false, false, false, false, false, false, false, false);
      pvalue.capability.octet9.proSel2End = new Asn1Boolean(true);
      pvalue.capability.octet9.a2xepc5 = new Asn1Boolean(true);
      pvalue.capability.octet9.unper = new Asn1Boolean(true);
      pvalue.capability.octet10 = new MMCapability_octet10(false, false, false, false, false, false, false, false);
      pvalue.capability.octet10.slvi = new Asn1Boolean(true);
      pvalue.capability.octet10.rsppc5 = new Asn1Boolean(true);
      pvalue.capability.octet11 = new MMCapability_octet11();
      pvalue.capability.octet11.mcsiu = new Asn1Boolean(true);

      pvalue.securityCapability = new com.objsys.nas.TS24501IES.UESecurityCapability();
      pvalue.securityCapability.length = new Asn1Integer(235);      
      pvalue.securityCapability.ea0 = new Asn1Boolean(true);
      pvalue.securityCapability.ea1 = new Asn1Boolean(true);
      pvalue.securityCapability.ea2 = new Asn1Boolean(true);
      pvalue.securityCapability.ea3 = new Asn1Boolean(true);
      pvalue.securityCapability.ea4 = new Asn1Boolean(true);
      pvalue.securityCapability.ea5 = new Asn1Boolean(false);
      pvalue.securityCapability.ea6 = new Asn1Boolean(false);
      pvalue.securityCapability.ea7 = new Asn1Boolean(false);
      pvalue.securityCapability.ia0 = new Asn1Boolean(true);
      pvalue.securityCapability.ia1 = new Asn1Boolean(false);
      pvalue.securityCapability.ia2 = new Asn1Boolean(false);
      pvalue.securityCapability.ia3 = new Asn1Boolean(false);
      pvalue.securityCapability.ia4 = new Asn1Boolean(false);
      pvalue.securityCapability.ia5 = new Asn1Boolean(false);
      pvalue.securityCapability.ia6 = new Asn1Boolean(false);
      pvalue.securityCapability.ia7 = new Asn1Boolean(false);

      pvalue.requestedNSSAI = new NSSAI();
      pvalue.requestedNSSAI.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.requestedNSSAI.contents = new SNSSAI[1];
      pvalue.requestedNSSAI.contents[0] = new SNSSAI();
      pvalue.requestedNSSAI.contents[0].length = new Asn1Integer(198);
      pvalue.requestedNSSAI.contents[0].sst = new SST(170);
      pvalue.requestedNSSAI.contents[0].sd = new SD(8746971);
      {
         byte testdata[] = { 
         (byte)0xe1 };
         pvalue.requestedNSSAI.contents[0].mappedSST = new Asn1OctetString(testdata);
      }
      {
         byte testdata[] = { 
         (byte)0x99, (byte)0x9a, (byte)0x4b };
         pvalue.requestedNSSAI.contents[0].mappedSD = new Asn1OctetString(testdata);
      }

      pvalue.lastVisitedTAI = new com.objsys.nas.TS24501IES.TrackingAreaIdent();
      pvalue.lastVisitedTAI.mcc_mnc = new MCCMNCPair();
      pvalue.lastVisitedTAI.mcc_mnc.mcc = new TBCDString3("410");
      pvalue.lastVisitedTAI.mcc_mnc.mnc = new TBCDString3("019");
         
      {
            byte testdata[] = { 
               (byte)0xbe, (byte)0x0a, (byte)0x77 };
            pvalue.lastVisitedTAI.tac = new com.objsys.nas.TS24501IES.TrackingAreaCode();
            pvalue.lastVisitedTAI.tac.value = testdata;
      }

      pvalue.s1NetworkCapability = new UENetworkCapability();
      pvalue.s1NetworkCapability.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.s1NetworkCapability.epsEncryptAlgs = new EPSEncryptAlgsSupported();
      pvalue.s1NetworkCapability.epsEncryptAlgs.eea0 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.epsEncryptAlgs.x128_eea1 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.epsEncryptAlgs.x128_eea2 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.epsEncryptAlgs.eea3 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.epsEncryptAlgs.eea4 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.epsEncryptAlgs.eea5 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.epsEncryptAlgs.eea6 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.epsEncryptAlgs.eea7 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.epsIntegAlgs = new EPSIntegAlgsSupported();
      pvalue.s1NetworkCapability.epsIntegAlgs.eia0 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.epsIntegAlgs.eia1 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.epsIntegAlgs.eia2 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.epsIntegAlgs.eia3 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.epsIntegAlgs.eia4 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.epsIntegAlgs.eia5 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.epsIntegAlgs.eia6 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.epsIntegAlgs.eia7 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.umtsEncryptAlgs = new UMTSEncryptAlgsSupported();
      pvalue.s1NetworkCapability.umtsEncryptAlgs.uea0 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.umtsEncryptAlgs.uea1 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.umtsEncryptAlgs.uea2 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.umtsEncryptAlgs.uea3 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.umtsEncryptAlgs.uea4 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.umtsEncryptAlgs.uea5 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.umtsEncryptAlgs.uea6 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.umtsEncryptAlgs.uea7 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet6 = new UENetworkCapability_octet6();
      pvalue.s1NetworkCapability.octet6.ucs2 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet6.umtsIntegAlgs = new UMTSIntegAlgsSupported();
      pvalue.s1NetworkCapability.octet6.umtsIntegAlgs.uia1 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet6.umtsIntegAlgs.uia2 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet6.umtsIntegAlgs.uia3 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet6.umtsIntegAlgs.uia4 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet6.umtsIntegAlgs.uia5 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet6.umtsIntegAlgs.uia6 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet6.umtsIntegAlgs.uia7 = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet7 = new UENetworkCapability_octet7();
      pvalue.s1NetworkCapability.octet7.proSedd = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet7.proSe = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet7.h245_ash = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet7.acc_csfb = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet7.lpp = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet7.lcs = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet7.x1xSR_VCC = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet7.nf = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet8 = new UENetworkCapability_octet8();
      pvalue.s1NetworkCapability.octet8.ePCO = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet8.hc_CP_CIoT = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet8.erwoPDN = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet8.s1_Udata = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet8.upCIoT = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet8.cpCIoT = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet8.prose_relay = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet8.proSedc = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet9 = new UENetworkCapability_octet9();
      pvalue.s1NetworkCapability.octet9.bearers = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet9.sgc = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet9.n1Mode = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet9.dcnr = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet9.cpBackoff = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet9.restrictEC = new Asn1Boolean(false);
      pvalue.s1NetworkCapability.octet9.v2xPC5 = new Asn1Boolean(true);
      pvalue.s1NetworkCapability.octet9.multDRB = new Asn1Boolean(true);

      pvalue.uplinkStat = new UplinkDataStatus();
      pvalue.uplinkStat.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.uplinkStat.psi_3 = new Asn1Boolean(true);
      pvalue.uplinkStat.psi_0 = new Asn1Boolean(true);
      pvalue.uplinkStat.psi_13 = new Asn1Boolean(true);
      pvalue.uplinkStat.psi_1 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_2 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_4 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_5 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_6 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_7 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_8 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_9 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_10 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_11 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_12 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_14 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_15 = new Asn1Boolean(false);

      pvalue.sessionStat = new PDUSessionStatus();
      pvalue.sessionStat.length = new Asn1Integer(10);
      pvalue.sessionStat.psi_7 = new Asn1Boolean(true);
      pvalue.sessionStat.psi_2 = new Asn1Boolean(true);
      pvalue.sessionStat.psi_13 = new Asn1Boolean(true);
      pvalue.sessionStat.psi_0 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_1 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_3 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_4 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_5 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_6 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_8 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_9 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_10 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_11 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_12 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_14 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_15 = new Asn1Boolean(false);

      pvalue.micoInd = new MICOIndication();
      pvalue.micoInd.sprti = new Asn1Boolean(true);
      pvalue.micoInd.raai = new Asn1Boolean(false);

      pvalue.ueStat = new UEStatus();
      pvalue.ueStat.n1RegStatus = new Asn1Boolean(true);
      pvalue.ueStat.s1RegStatus = new Asn1Boolean(false);

      pvalue.ueUsage = new UEUsageSetting();
      pvalue.ueUsage.length = new Asn1Integer(15);
      pvalue.ueUsage.usage = new Asn1Boolean(false);

      pvalue.containerType = PayloadContainerType.uePolicy();
      pvalue.container = new RegRequest_container();
      OpaqueData odata = new OpaqueData();
      odata.length = new Asn1Integer(2);
      {
         byte testdata[] = { (byte)0xc2, (byte)0x39 };
         odata.contents = new Asn1OctetString(testdata);
      }
      pvalue.container.set_uePolicy(odata);

      pvalue.updateType = new UpdateType();
      pvalue.updateType.length = new Asn1Integer(2);
      pvalue.updateType.epsPnbCIoT = new Asn1Integer(2);
      pvalue.updateType.pnbCIoT = new Asn1Integer(3);
      pvalue.updateType.ngranUpd = new Asn1Boolean(true);
      pvalue.updateType.smsReq = new Asn1Boolean(false);
      pvalue.mV16ExtPresent = true;
      pvalue.ueRadioCapabilityId = new UERadioCapId();
      {
         byte testdata[] = { (byte)0xff };
         pvalue.ueRadioCapabilityId.capId = new Asn1OctetString(testdata);
      }

      pvalue.reqMappedNSSAI = new MappedNSSAI();
      pvalue.reqMappedNSSAI.length = new Asn1Integer(0);  // Calculated automatically...
      pvalue.reqMappedNSSAI.contents = new MappedSNSSAIContent[1];
      pvalue.reqMappedNSSAI.contents[0] = new MappedSNSSAIContent();
      pvalue.reqMappedNSSAI.contents[0].length = new Asn1Integer(0);  // Calculated automatically...
      
      pvalue.reqMappedNSSAI.contents[0].mappedSST = new Asn1OctetString();
      pvalue.reqMappedNSSAI.contents[0].mappedSST.value = new byte[1];
      pvalue.reqMappedNSSAI.contents[0].mappedSST.value[0] = (byte)0xee;
      pvalue.reqMappedNSSAI.contents[0].mappedSD = new Asn1OctetString();
      pvalue.reqMappedNSSAI.contents[0].mappedSD.value = new byte[3];
      pvalue.reqMappedNSSAI.contents[0].mappedSD.value[0] = (byte)0xdd;
      pvalue.reqMappedNSSAI.contents[0].mappedSD.value[1] = (byte)0xcc;
      pvalue.reqMappedNSSAI.contents[0].mappedSD.value[2] = (byte)0xbb;

      pvalue.addlInfoRequested = new AdditionalInfoRequested();
      pvalue.addlInfoRequested.cipherKey = new Asn1Boolean(true);

      pvalue.wusAssistInfo = new WUSAssistanceInfo();
      pvalue.wusAssistInfo.length = new Asn1Integer(0);  // Calculated automatically...
      pvalue.wusAssistInfo.types = new WUSAssistanceInfo_types();
      pvalue.wusAssistInfo.types.elements = new WUSAssistInfoType[1];
      pvalue.wusAssistInfo.types.elements[0] = new WUSAssistInfoType();
      pvalue.wusAssistInfo.types.elements[0].infoType = InformationType.itUEPagingProbInfo();
      pvalue.wusAssistInfo.types.elements[0].infoValue = new Asn1Integer(30);

      pvalue.n5gcInd = new N5GCIndication();
      pvalue.n5gcInd.n5gcReg = new Asn1Boolean(true);

      pvalue.reqNBN1Params = new NBN1ModeDRXParams();
      pvalue.reqNBN1Params.drxValue = new Asn1Integer(11);

      pvalue.mV17ExtPresent = true;
      pvalue.disasterPLMN = new PLMNId();
      pvalue.disasterPLMN.length = new Asn1Integer(0);  // Calculated automatically...
      pvalue.disasterPLMN.contents = new MCCMNCPair();
      pvalue.disasterPLMN.contents.mcc = new TBCDString3("620");
      pvalue.disasterPLMN.contents.mnc = new TBCDString3("900");

      pvalue.mV18ExtPresent = true;
      pvalue.unavailDuration = new TimeDuration();
      pvalue.unavailDuration.length = new Asn1Integer(0);  // Calculated automatically...
      pvalue.unavailDuration.duration = new Asn1Integer(10000000);

      // Create a message buffer object and encode the record

      Asn1NasEncodeBuffer encodeBuffer = new Asn1NasEncodeBuffer();

      // Enable bit field tracing

      if (trace) {
         encodeBuffer.getTraceHandler().enable();
      }  

      try {

          pdu.encode (encodeBuffer);

          if (trace) {
              System.out.println ("Encoding was successful");
              System.out.println ("Hex dump of encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump:");
              encodeBuffer.binDump ("message");
          }

          // Write the encoded record to a file

          encodeBuffer.write (new FileOutputStream (filename));

          // Generate a dump file for comparisons

          encodeBuffer.hexDump 
              (new PrintStream (new FileOutputStream ("message.dmp")));
      }
      catch (Exception e) {
          if (trace) {
              System.out.println ("Hex dump of partially encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump of partially encoded record:");
              encodeBuffer.binDump ("message");
          }

          System.out.println (e.getMessage());
          e.printStackTrace();           
          System.exit(-1);
      }
   }
}
