import com.objsys.asn1j.runtime.*;
import java.io.*;

import com.objsys.nas.TS24501Msgs.*;
import com.objsys.nas.TS24501IES.*;
import com.objsys.nas.TS24301IES.*;
import com.objsys.nas.TS24008IES.*;

public class Writer {


   public static void main (String args[]) {
       String filename = new String ("message.dat");
       boolean trace = true;

      // Process command line arguments

      if (args.length > 0) {
         for (int i = 0; i < args.length; i++) {
            if (args[i].equals ("-v")) 
                Diag.instance().setEnabled (true);
            else if (args[i].equals ("-o")) 
                filename = new String (args[++i]);
            else if (args[i].equals ("-notrace")) trace = false;
            else {
                System.out.println ("usage: Writer [ -v ] [ -o <filename>");
                System.out.println ("   -v  verbose mode: print trace info");
                System.out.println ("   -o <filename>  " +
                                    "write encoded msg to <filename>");
                System.out.println ("   -notrace  do not display trace info");
                return;
            }
         }
      }

      // Create a data object and populate it with the data to be encoded
      com.objsys.nas.TS24501Msgs.PDU pdu = new PDU();
      com.objsys.nas.TS24501Msgs.ServRequest data = new ServRequest();
      com.objsys.nas.TS24501Msgs.ServRequest pvalue = data;
      /* Populate data structure */
      pdu.protoDiscr = NAS5GProtoDiscr.mobMgmt5G();
      pdu.hdrData = new PDU_hdrData();
      PDU_hdrData_mm tempVar1 = new PDU_hdrData_mm();
      pdu.hdrData.set_mm(tempVar1);

      tempVar1.secHdrType = NAS5GSecHdrType.noSec();
      pdu.msgType = new _NAS5G_PROTOCOL_CLASS_msgType(_TS24501MsgsValues.mt_ServRequest5G);
      pdu.data = pvalue;
      pvalue.serviceType = com.objsys.nas.TS24501IES.ServiceType.emerSvc();
      pvalue.nasKeySetIdent = new NASKeySetIdentifier();
      pvalue.nasKeySetIdent.tsc = new Asn1Boolean(false);
      pvalue.nasKeySetIdent.ident = new Asn1Integer(2);
      pvalue.stmsi = new com.objsys.nas.TS24501IES.MobileIdentity();
      MobileIdentity_STMSI tempVar2 = new MobileIdentity_STMSI();
      pvalue.stmsi.set_stmsi(tempVar2);

      tempVar2.amfSetID = new Asn1Integer(13);
      tempVar2.amfPointer = new Asn1Integer(8);
      {
          byte testdata[] = { 
         (byte)0xe3, (byte)0x42, (byte)0x47, (byte)0xa0 };
         tempVar2.tmsi = new Asn1OctetString(testdata);
      }
      pvalue.uplinkStat = new UplinkDataStatus();
      pvalue.uplinkStat.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.uplinkStat.psi_3 = new Asn1Boolean(true);
      pvalue.uplinkStat.psi_0 = new Asn1Boolean(true);
      pvalue.uplinkStat.psi_13 = new Asn1Boolean(true);
      pvalue.uplinkStat.psi_1 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_2 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_4 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_5 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_6 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_7 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_8 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_9 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_10 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_11 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_12 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_14 = new Asn1Boolean(false);
      pvalue.uplinkStat.psi_15 = new Asn1Boolean(false);      
      
      pvalue.sessionStat = new PDUSessionStatus();
      pvalue.sessionStat.length = new Asn1Integer(10);
      pvalue.sessionStat.psi_7 = new Asn1Boolean(true);
      pvalue.sessionStat.psi_2 = new Asn1Boolean(true);
      pvalue.sessionStat.psi_13 = new Asn1Boolean(true);
      pvalue.sessionStat.psi_0 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_1 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_3 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_4 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_5 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_6 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_8 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_9 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_10 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_11 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_12 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_14 = new Asn1Boolean(false);
      pvalue.sessionStat.psi_15 = new Asn1Boolean(false);      

      pvalue.mV17ExtPresent = true;
      pvalue.ueRequestType = new UERequestType();
      pvalue.ueRequestType.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.ueRequestType.type = com.objsys.nas.TS24301IES.UERequestTypes.ueNASRelease();

      pvalue.pagingRestriction = new PagingRestriction();
      pvalue.pagingRestriction.length = new Asn1Integer(0); /* length will be calculated */
      pvalue.pagingRestriction.type = com.objsys.nas.TS24301IES.RestrictionTypes.rtExceptVoicePDN();
      pvalue.pagingRestriction.octet4 = new PagingRestriction_octet4();
      pvalue.pagingRestriction.octet4.ebi7 = new Asn1Boolean(true);
      pvalue.pagingRestriction.octet4.ebi6 = new Asn1Boolean(false);
      pvalue.pagingRestriction.octet4.ebi5 = new Asn1Boolean(false);
      pvalue.pagingRestriction.octet4.ebi4 = new Asn1Boolean(false);
      pvalue.pagingRestriction.octet4.ebi3 = new Asn1Boolean(true);
      pvalue.pagingRestriction.octet4.ebi2 = new Asn1Boolean(true);
      pvalue.pagingRestriction.octet4.ebi1 = new Asn1Boolean(false);
      pvalue.pagingRestriction.octet4.ebi0 = new Asn1Boolean(false);

      pvalue.pagingRestriction.octet5 = new PagingRestriction_octet5();
      pvalue.pagingRestriction.octet5.ebi15 = new Asn1Boolean(false);
      pvalue.pagingRestriction.octet5.ebi14 = new Asn1Boolean(false);
      pvalue.pagingRestriction.octet5.ebi13 = new Asn1Boolean(true);
      pvalue.pagingRestriction.octet5.ebi12 = new Asn1Boolean(false);
      pvalue.pagingRestriction.octet5.ebi11 = new Asn1Boolean(false);
      pvalue.pagingRestriction.octet5.ebi10 = new Asn1Boolean(true);
      pvalue.pagingRestriction.octet5.ebi9 = new Asn1Boolean(false);
      pvalue.pagingRestriction.octet5.ebi8 = new Asn1Boolean(true);
            
      // Create a message buffer object and encode the record
      Asn1NasEncodeBuffer encodeBuffer = new Asn1NasEncodeBuffer();

      // Enable bit field tracing

      if (trace) {
         encodeBuffer.getTraceHandler().enable();
      }  

      try {

          pdu.encode (encodeBuffer);

          if (trace) {
              System.out.println ("Encoding was successful");
              System.out.println ("Hex dump of encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump:");
              encodeBuffer.binDump ("message");
          }

          // Write the encoded record to a file

          encodeBuffer.write (new FileOutputStream (filename));

          // Generate a dump file for comparisons

          encodeBuffer.hexDump 
              (new PrintStream (new FileOutputStream ("message.dmp")));
      }
      catch (Exception e) {
          if (trace) {
              System.out.println ("Hex dump of partially encoded record:");
              encodeBuffer.hexDump ();
              System.out.println ("Binary dump of partially encoded record:");
              encodeBuffer.binDump ("message");
          }

          System.out.println (e.getMessage());
          e.printStackTrace();           
          System.exit(-1);
      }
   }
}
